local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')
local Mm = E:GetModule('Minimap')
local DTB = E:GetModule('DTBars')
local M = E:GetModule('Misc');

local addon = select(1,...)
local EP = LibStub("LibElvUIPlugin-1.0")

E.Minimap = Mm;

--------------------------------------------------------
-- System Settable Variables
--------------------------------------------------------

local top = CreateFrame('Frame', 'Top_Bar', E.UIParent);
local bottom = CreateFrame('Frame', 'Bottom_Bar', E.UIParent);
local lchat = CreateFrame('Frame', 'LeftChatDataBar', E.UIParent);
local rchat = CreateFrame('Frame', 'RightChatDataBar', E.UIParent);
local rchat2 = CreateFrame('Frame', 'RightChatDataBar2', E.UIParent);
local db1 = CreateFrame('Frame', 'ExtraOne', E.UIParent);
local db2 = CreateFrame('Frame', 'ExtraTwo', E.UIParent);
local db3 = CreateFrame('Frame', 'ExtraThree', E.UIParent);
local db4 = CreateFrame('Frame', 'ExtraFour', E.UIParent);
local db5 = CreateFrame('Frame', 'ExtraFive', E.UIParent);
local db6 = CreateFrame('Frame', 'ExtraSix', E.UIParent);

local bars = {
	Top_Bar = {"top", "Top_Bar","TOP", 0, Top_Bar, 3, "Top Bar"},
	Bottom_Bar = {"bottom", "Bottom_Bar", "BOTTOM", 0, Bottom_Bar, 3, "Bottom Bar"},
	ExtraOne = {"db1", "db1", "BOTTOM" , (E.screenwidth/5), ExtraOne, 3, "Extra One"},
	ExtraTwo = {"db2", "db2", "BOTTOM", -(E.screenwidth/5), ExtraTwo, 3, "Extra Two"},
	ExtraThree = {"db3", "db3", "TOP", (E.screenwidth/5), ExtraThree, 3, "Extra Three"},
	ExtraFour = {"db4", "db4", "TOP", -(E.screenwidth/5), ExtraFour, 3, "Extra Four"},
	ExtraFive = {"db5", "db5", "TOPLEFT", (E.screenwidth/2), ExtraFive, 3, "Extra Five"},
	ExtraSix = {"db6", "db6", "TOPRIGHT", -(E.screenwidth/2), ExtraSix, 3, "Extra Six"},
}

local backgrounds = {
	BottomBG = {"BottomBG"},
	LeftBG = {"LeftBG"},
	RightBG = {"RightBG"},
	ExtraOneBG = {"ExtraOneBG"},
	ExtraTwoBG = {"ExtraTwoBG"},
}

DT.PointLocation = {
	[1] = 'middle',
	[2] = 'left',
	[3] = 'right',
	[4] = 'farleft',
	[5] = 'farright',
}

function DT:GetNewDataPanelPoint(panel, i, numPoints)
	if numPoints == 1 then
		return 'CENTER', panel, 'CENTER'
	else
		if i == 1 then
			return 'CENTER', panel, 'CENTER'
		elseif i == 2 then
			return 'RIGHT', panel.dataPanels['middle'], 'LEFT', -4, 0
		elseif i == 3 then
			return 'LEFT', panel.dataPanels['middle'], 'RIGHT', 4, 0
		elseif i == 4 then
			return 'RIGHT', panel.dataPanels['left'], 'LEFT', -4, 0
		elseif i == 5 then
			return 'LEFT', panel.dataPanels['right'], "RIGHT", 4, 0
		end
	end

end

function DT:GetOldDataPanelPoint(panel, i, numPoints)
	if numPoints == 1 then
		return 'CENTER', panel, 'CENTER'
	else
		if i == 1 then
			return 'CENTER', panel, 'CENTER'
		elseif i == 2 then
			return 'RIGHT', panel.dataPanels['middle'], 'LEFT', -4, 0
		elseif i == 3 then
			return 'LEFT', panel.dataPanels['middle'], 'RIGHT', 4, 0
		end
	end
end

function DT:GetDataPanelPoint(panel, i, numPoints)

	
	
		return DT:GetNewDataPanelPoint(panel, i, numPoints)
		
	
end



--------------------------------------------------------
-- Language Variables
--------------------------------------------------------


L['Top_Bar'] = 'Top Datatext';
L['Bottom_Bar'] = 'Bottom Datatext';
L['LeftChatDataBar'] = 'Left Chat Tab';
L['RightChatDataBar'] = 'Right Chat Tab';
L['RightChatDataBar2'] = 'Right Chat Tab 2';
L['ExtraOne'] = 'Extra One';
L['ExtraTwo'] = 'Extra Two';
L['ExtraThree'] = 'Extra Three';
L['ExtraFour'] = 'Extra Four';
L['ExtraFive'] = 'Extra Five';
L['ExtraSix'] = 'Extra Six';

------DAS CODE------


function DTB:CreateDataPanels(self, name, point, x, slot, short)
	self:SetFrameStrata('LOW')
	self:SetFrameLevel(4)
	self:Point(point, E.UIParent, point, x, 0); 
	
	DT:RegisterPanel(self, slot, 'ANCHOR_BOTTOM', 0, -4)
	self:Hide()
end

function DTB:Resize()
	local db = E.db.DTBars.datatexts
	for _,v in pairs(bars) do
		v[5]:SetWidth(db[v[2]].Width)
		v[5]:SetHeight(22)
	end
	DT:UpdateAllDimensions()
end

function DTB:ExtraDBSetup()
	local db = E.db.DTBars.datatexts
	for _,v in pairs(bars) do
		if db[v[2]].Enabled then
			v[5]:Show()
		else
			v[5]:Hide()
		end
		
		if not db[v[2]].Hide then
			if db[v[2]].Transparent then
				v[5]:SetTemplate("Transparent")
			elseif db[v[2]].ClassColor then
				v[5]:SetTemplate("ClassColor");
			else
				v[5]:SetTemplate("Default", true)
			end
		end
	end
end

function DTB:RegisterHide()
	local db = E.db.DTBars.datatexts
	for k,v in pairs(bars) do
		if db[v[2]].PetBattleHide then
			E.FrameLocks[k] = true
		else
			E.FrameLocks[k] = nil
		end
	end
	
	local bg = E.db.DTBars.Backgrounds
	for k,v in pairs(backgrounds) do
		if bg[v[1]].PetHide then
			E.FrameLocks[k] = true
		else
			E.FrameLocks[k] = nil
		end
	
	end
end


function DT:CombatShow()
	local db = E.db.DTBars.datatexts
	for _,v in pairs(bars) do

		if db[v[2]].Enabled then
			if db[v[2]].CombatHide then
				v[5]:Show()
			end
		end
		
	end
end

function DT:CombatHide()
	local db = E.db.DTBars.datatexts
	for _,v in pairs(bars) do		
		if db[v[2]].Enabled then
			if db[v[2]].CombatHide then
				v[5]:Hide()
			end
		end
	end
end





function DTB:MouseOver()
	local db = E.db.DTBars.datatexts
	for _,v in pairs(bars) do		
		if db[v[2]].MouseOver then
			
		v[5]:SetScript("OnUpdate", function (self,event,...)
			if MouseIsOver(v[5]) then
				v[5]:SetAlpha(1)
			else
				v[5]:SetAlpha(0)
			end
		end)

		else
			v[5]:SetScript("OnUpdate", nil)
			v[5]:SetAlpha(1)
			
		end
	end
end


function DTB:Update()
	DTB:ExtraDataBarSetup()
	DTB:Resize()
end


function DTB:ShowTabs()
	if E.db.DTBars.datatexts.RightChatDataBar.Enabled then
		rchat:Show()
		rchat2:Show()
	end
	
	if E.db.DTBars.datatexts.LeftChatDataBar.Enabled then
		lchat:Show()
	end
end


function DTB:Initialize()


	if E.db.datatexts.DTBars then
		E.db.DTBars.datatexts = {}
		E:CopyTable(E.db.DTBars.datatexts, E.db.datatexts.DTBars)
		E.db.datatexts.DTBars = nil
	end
	self.db = E.db.DTBars.datatexts
	
	local db = E.db.DTBars.datatexts;
	for _,v in pairs(bars) do
		DTB:CreateDataPanels(v[5], v[2], v[3], v[4], db[v[2]].DataPlaces, v[1])
	end
	DTB:Resize()
	
	for _,v in pairs(bars) do
		E:CreateMover(v[5], v[7].."_Mover", L[v[7]])
	end

	DTB:rchat_tab_setup()
	DTB:lchat_tab_setup()
	
	DTB:ExtraDBSetup()
	
	DTB:RegisterHide()
	
	DTB:createTopPanel()
	DTB:createBottomPanel()
	
	DTB:MouseOver()
	DTB:PanelSetUp()
	DTB:ShowTabs()
	
	DT:RegisterEvent("PLAYER_REGEN_ENABLED", "CombatShow");
	
	DT:RegisterEvent("PLAYER_REGEN_DISABLED", "CombatHide");
	
	EP:RegisterPlugin(addon, DTB.addOptions)
end


db = db or {}

--------------------------------------------------------
-- Left Chat Tab
--------------------------------------------------------

function DTB:lchat_tab_setup()
	do
		lchat:Size(LeftChatTab:GetWidth() / 3, 22)
		lchat:Point("TOPRIGHT", LeftChatTab, "TOPRIGHT", 0, 0)
		lchat:SetFrameStrata('LOW')
		LeftChatTab:HookScript("OnHide", function() lchat:Hide() end)
		LeftChatTab:HookScript("OnShow", function() lchat:Show() end)		
	end
end

do
	
	lchat.db = {key='LeftChatDataBar', value = true}
	DT:RegisterPanel(lchat, 1, 'ANCHOR_BOTTOM', 0, -4)
	lchat:Hide()
end

--------------------------------------------------------
-- Right Chat Tab 1
--------------------------------------------------------

function DTB:rchat_tab_setup()
	do
		rchat:Size(RightChatPanel:GetWidth() /3, 22)
		rchat:Point("RIGHT", RightChatDataBar2, "LEFT")
		rchat:SetFrameStrata('LOW')

		rchat2:Size((RightChatPanel:GetWidth() / 3),22)
		rchat2:Point("TOPRIGHT", RightChatTab, "TOPRIGHT", 0, 0)
		rchat2:SetFrameStrata('LOW')

		RightChatTab:HookScript("OnHide", function() 
			rchat:Hide() 
			rchat2:Hide() 
		end)
		RightChatTab:HookScript("OnShow", function() 
			rchat:Show() 
			rchat:SetAlpha(RightChatTab:GetAlpha()) 
			rchat2:Show() 
			rchat2:SetAlpha(RightChatTab:GetAlpha()) 
		end)
	end
end

 do
	
	rchat.db ={key='RightChatDataBar', value = true}
	DT:RegisterPanel(rchat, 1, 'ANCHOR_BOTTOM', 0, -4)
	rchat:Hide()
end

--------------------------------------------------------
-- Right Chat Tab 2
--------------------------------------------------------

 do
	
	rchat2.db = {key='RightChatDataBar2', value = true}
	DT:RegisterPanel(rchat2, 1, 'ANCHOR_BOTTOM', 0, -4)
	rchat2:Hide()
end










