---Credits to DarthPredator for letting me use his code.

local E, L, V, P, G, _ =  unpack(ElvUI);
local BG = E:NewModule('BackGrounds', 'AceHook-3.0', 'AceEvent-3.0');

local BGb = CreateFrame('Frame', "BottomBG", E.UIParent);
local BGl = CreateFrame('Frame', "LeftBG", E.UIParent);
local BGr = CreateFrame('Frame', "RightBG", E.UIParent);
local BGeOne = CreateFrame('Frame', "ExtraOneBG", E.UIParent);
local BGeTwo = CreateFrame('Frame', "ExtraTwoBG", E.UIParent);

local Tn = {
	BottomBG = {BGb,"BottomBG"},
	LeftBG = {BGl,"LeftBG"},
	RightBG = {BGr,"RightBG"},
	ExtraOneBG = {BGeOne,"ExtraOneBG"},
	ExtraTwoBG = {BGeTwo, "ExtraTwoBG"},
}



function BG:FramesCreate()
	local db = E.db.DTBars.Backgrounds
	for _,v in pairs(Tn) do
		v[1]:SetFrameLevel(1)
		v[1]:SetTemplate('Default', true)
		v[1]:SetScript("OnShow", function() v[1]:SetFrameStrata('BACKGROUND') end)
		v[1]:Hide()
	end
	
end

function BG:FramesSize()
	local db = E.db.DTBars.Backgrounds
	for _,v in pairs(Tn) do
		v[1]:SetSize(db[v[2]].Width, db[v[2]].Height)
	end
end

function BG:FramesPositions()
	BGb:Point("BOTTOM", E.UIParent, "BOTTOM", 0 + E.db.DTBars.Backgrounds.BottomBG.XOff, 21 + E.db.DTBars.Backgrounds.BottomBG.YOff); 
	BGl:Point("BOTTOMRIGHT", E.UIParent, "BOTTOM", -(E.screenwidth/4 + 32)/2 - 1 + E.db.DTBars.Backgrounds.LeftBG.XOff, 21 + E.db.DTBars.Backgrounds.LeftBG.YOff); 
	BGr:Point("BOTTOMLEFT", E.UIParent, "BOTTOM", (E.screenwidth/4 + 32)/2 + 1 + E.db.DTBars.Backgrounds.RightBG.XOff, 21 + E.db.DTBars.Backgrounds.RightBG.YOff); 
	BGeOne:Point("TOPLEFT", E.UIParent, "CENTER", (E.screenwidth/4 + 32)/2 + 1 + E.db.DTBars.Backgrounds.ExtraOneBG.XOff, 21 + E.db.DTBars.Backgrounds.ExtraOneBG.YOff);
	BGeTwo:Point("TOPRIGHT", E.UIParent, "CENTER", -(E.screenwidth/4 + 32)/2 + 1 + E.db.DTBars.Backgrounds.ExtraTwoBG.XOff, 21 + E.db.DTBars.Backgrounds.ExtraTwoBG.YOff);
end


function BG:FramesVisibility()
	local db = E.db.DTBars.Backgrounds
	for _,v in pairs(Tn) do
		if db[v[2]].Enabled then
			v[1]:Show()
		else
			v[1]:Hide()
		end
	
	
		if db[v[2]].Transparent then
			v[1]:SetTemplate("Transparent")
		elseif db[v[2]].ClassColor then
			v[1]:SetTemplate("ClassColor");
		else
			v[1]:SetTemplate("Default", true)
		end
	end
end

function BG:UpdateFrames()
	BG:FramesSize()
	BG:FramesPositions()
	BG:FramesVisibility()
end

function BG:RegisterHide()
	local db = E.db.DTBars.Backgrounds
	for k,v in pairs(Tn) do
		if db[v[2]].PetHide then
			E.FrameLocks[k] = true
		else
			E.FrameLocks[k] = nil
		end
	end
end

function BG:Initialize()
	BG:FramesCreate()
	BG:UpdateFrames()
	BG:RegisterHide()
end

E:RegisterModule(BG:GetName())