local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')
local BG = E:GetModule('BackGrounds')
local DTB = E:GetModule('DTBars')

function DTB:setOptions()
E.Options.args.DTBars.args.Backgrounds = {
	type = "group",
	name = "Backgrounds",
	order = 605,
	args = {
		LeftBG = {
			order = 1,
			type = "group",
			name = "Left Background",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.Enabled end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.Enabled = value; BG:FramesVisibility() end,
				},
				Height = {
					order = 2,
					type = "range",
					name = "Height",
					min = 0, max = E.screenheight/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.Height end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.Height = value; BG:FramesSize() end,
				},
				Width = {
					order = 3,
					type = "range",
					name = "Width",
					min = 0, max = E.screenwidth, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.Width end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.Width = value; BG:FramesSize() end,
				},
				Xoff = {
					order = 4,
					type = "range",
					name = "X-Offset",
					min = -E.screenwidth/2, max = E.screenwidth/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.XOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.XOff = value; BG:FramesPositions() end,
				},
				Yoff = {
					order = 5,
					type = "range",
					name = "Y-Offset",
					min = -21, max = E.screenheight, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.YOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.YOff = value; BG:FramesPositions() end,
				},
				PetHide = {
					order = 6,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.PetHide end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.PetHide = value; BG:RegisterHide() end,
				},
				Transparent = {
					order = 7,
					type = "toggle",
					name = L['Panel Transparency'],
					disabled = function() return not E.db.DTBars.Backgrounds.LeftBG.Enabled or E.db.DTBars.Backgrounds.LeftBG.ClassColor end,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.Transparent end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.Transparent = value; BG:FramesVisibility() end,	
				},
				ClassColor = {
					order = 8,
					type = "toggle",
					name = L['Class Color'],
					disabled = function() return not E.db.DTBars.Backgrounds.LeftBG.Enabled or E.db.DTBars.Backgrounds.LeftBG.Transparent end,
					get = function(info) return E.db.DTBars.Backgrounds.LeftBG.ClassColor end,
					set = function(info, value) E.db.DTBars.Backgrounds.LeftBG.ClassColor = value; BG:FramesVisibility() end,
				},
			}			
		},
		RightBG = {
			order = 2,
			type = "group",
			name = "Right Background",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.Enabled end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.Enabled = value; BG:FramesVisibility() end,
				},
				Height = {
					order = 2,
					type = "range",
					name = "Height",
					min = 0, max = E.screenheight/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.Height end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.Height = value; BG:FramesSize() end,
				},
				Width = {
					order = 3,
					type = "range",
					name = "Width",
					min = 0, max = E.screenwidth, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.Width end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.Width = value; BG:FramesSize() end,
				},
				Xoff = {
					order = 4,
					type = "range",
					name = "X-Offset",
					min = -E.screenwidth/2, max = E.screenwidth/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.XOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.XOff = value; BG:FramesPositions() end,
				},
				Yoff = {
					order = 5,
					type = "range",
					name = "Y-Offset",
					min = -21, max = E.screenheight, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.YOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.YOff = value; BG:FramesPositions() end,
				},
				PetHide = {
					order = 6,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.PetHide end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.PetHide = value; BG:RegisterHide() end,
				},
				Transparent = {
					order = 7,
					type = "toggle",
					name = L['Panel Transparency'],
					disabled = function() return not E.db.DTBars.Backgrounds.RightBG.Enabled or E.db.DTBars.Backgrounds.RightBG.ClassColor end,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.Transparent end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.Transparent = value; BG:FramesVisibility() end,	
				},
				ClassColor = {
					order = 8,
					type = "toggle",
					name = L['Class Color'],
					disabled = function() return not E.db.DTBars.Backgrounds.RightBG.Enabled or E.db.DTBars.Backgrounds.RightBG.Transparent end,
					get = function(info) return E.db.DTBars.Backgrounds.RightBG.ClassColor end,
					set = function(info, value) E.db.DTBars.Backgrounds.RightBG.ClassColor = value; BG:FramesVisibility() end,
				},
			}			
		},
		BottomBG = {
			order = 3,
			type = "group",
			name = "Bottom Background",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.Enabled end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.Enabled = value; BG:FramesVisibility() end,
				},
				Height = {
					order = 2,
					type = "range",
					name = "Height",
					min = 0, max = E.screenheight/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.Height end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.Height = value; BG:FramesSize() end,
				},
				Width = {
					order = 3,
					type = "range",
					name = "Width",
					min = 0, max = E.screenwidth, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.Width end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.Width = value; BG:FramesSize() end,
				},
				Xoff = {
					order = 4,
					type = "range",
					name = "X-Offset",
					min = -E.screenwidth/2, max = E.screenwidth/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.XOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.XOff = value;  BG:FramesPositions() end,
				},
				Yoff = {
					order = 5,
					type = "range",
					name = "Y-Offset",
					min = -21, max = E.screenheight, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.YOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.YOff = value;  BG:FramesPositions() end,
				},
				PetHide = {
					order = 6,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.PetHide end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.PetHide = value; BG:RegisterHide() end,
				},
				Transparent = {
					order = 7,
					type = "toggle",
					name = L['Panel Transparency'],
					disabled = function() return not E.db.DTBars.Backgrounds.BottomBG.Enabled or E.db.DTBars.Backgrounds.BottomBG.ClassColor end,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.Transparent end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.Transparent = value; BG:FramesVisibility() end,	
				},
				ClassColor = {
					order = 8,
					type = "toggle",
					name = L['Class Color'],
					disabled = function() return not E.db.DTBars.Backgrounds.BottomBG.Enabled or E.db.DTBars.Backgrounds.BottomBG.Transparent end,
					get = function(info) return E.db.DTBars.Backgrounds.BottomBG.ClassColor end,
					set = function(info, value) E.db.DTBars.Backgrounds.BottomBG.ClassColor = value; BG:FramesVisibility() end,
				},
			}			
		},
		ExtraOneBG = {
			order = 4,
			type = "group",
			name = "Extra 1 Background",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.Enabled end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.Enabled = value; BG:FramesVisibility() end,
				},
				Height = {
					order = 2,
					type = "range",
					name = "Height",
					min = 0, max = E.screenheight/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.Height end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.Height = value; BG:FramesSize() end,
				},
				Width = {
					order = 3,
					type = "range",
					name = "Width",
					min = 0, max = E.screenwidth, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.Width end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.Width = value; BG:FramesSize() end,
				},
				Xoff = {
					order = 4,
					type = "range",
					name = "X-Offset",
					min = -E.screenwidth/2, max = E.screenwidth/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.XOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.XOff = value;  BG:FramesPositions() end,
				},
				Yoff = {
					order = 5,
					type = "range",
					name = "Y-Offset",
					min = -21, max = E.screenheight, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.YOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.YOff = value;  BG:FramesPositions() end,
				},
				PetHide = {
					order = 6,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.PetHide end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.PetHide = value; BG:RegisterHide() end,
				},
				Transparent = {
					order = 7,
					type = "toggle",
					name = L['Panel Transparency'],
					disabled = function() return not E.db.DTBars.Backgrounds.ExtraOneBG.Enabled or E.db.DTBars.Backgrounds.ExtraOneBG.ClassColor end,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.Transparent end,
					set = function(info, value) E.db.DTBars.datatexts.ExtraOneBG.Transparent = value; BG:FramesVisibility() end,	
				},
				ClassColor = {
					order = 8,
					type = "toggle",
					name = L['Class Color'],
					disabled = function() return not E.db.DTBars.Backgrounds.ExtraOneBG.Enabled or E.db.DTBars.Backgrounds.ExtraOneBG.Transparent end,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraOneBG.ClassColor end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraOneBG.ClassColor = value; BG:FramesVisibility() end,
				},
			}			
		},
		ExtraTwoBG = {
			order = 5,
			type = "group",
			name = "Extra 2 Background",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.Enabled end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.Enabled = value; BG:FramesVisibility() end,
				},
				Height = {
					order = 2,
					type = "range",
					name = "Height",
					min = 0, max = E.screenheight/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.Height end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.Height = value; BG:FramesSize() end,
				},
				Width = {
					order = 3,
					type = "range",
					name = "Width",
					min = 0, max = E.screenwidth, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.Width end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.Width = value; BG:FramesSize() end,
				},
				Xoff = {
					order = 4,
					type = "range",
					name = "X-Offset",
					min = -E.screenwidth/2, max = E.screenwidth/2, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.XOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.XOff = value;  BG:FramesPositions() end,
				},
				Yoff = {
					order = 5,
					type = "range",
					name = "Y-Offset",
					min = -21, max = E.screenheight, step = 1,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.YOff end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.YOff = value;  BG:FramesPositions() end,
				},
				PetHide = {
					order = 6,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.PetHide end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.PetHide = value; BG:RegisterHide() end,
				},
				Transparent = {
					order = 7,
					type = "toggle",
					name = L['Panel Transparency'],
					disabled = function() return not E.db.DTBars.Backgrounds.ExtraTwoBG.Enabled or E.db.DTBars.Backgrounds.ExtraTwoBG.ClassColor end,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.Transparent end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.Transparent = value; BG:FramesVisibility() end,	
				},
				ClassColor = {
					order = 8,
					type = "toggle",
					name = L['Class Color'],
					disabled = function() return not E.db.DTBars.Backgrounds.ExtraTwoBG.Enabled or E.db.DTBars.Backgrounds.ExtraTwoBG.Transparent end,
					get = function(info) return E.db.DTBars.Backgrounds.ExtraTwoBG.ClassColor end,
					set = function(info, value) E.db.DTBars.Backgrounds.ExtraTwoBG.ClassColor = value; BG:FramesVisibility() end,
				},
			}			
		}
	},
}
end

local DTFrame = CreateFrame('Frame')
DTFrame:RegisterEvent('ADDON_LOADED')
DTFrame:SetScript('OnEvent',function(self, event, addon)
	if event == 'ADDON_LOADED' and addon == 'ElvUI_Config' then
		DTB:setOptions()
		DTFrame:UnregisterEvent('ADDON_LOADED')
	end
end)