local E, L, V, P, G, _ =  unpack(ElvUI);

local DTB = E:GetModule('DTBars')

local topPanel = CreateFrame('Frame', 'topPanel', E.UIParent)
local bottomPanel = CreateFrame('Frame', 'bottomPanel', E.UIParent)

local panels = {
	TopPanel = {topPanel, "TopPanel"},
	BottomPanel = {bottomPanel, "BottomPanel"},
}

function DTB:createTopPanel()
	
	topPanel:SetPoint("TOPLEFT", E.UIParent, "TOPLEFT", -E.mult, E.mult)
	topPanel:SetPoint("TOPRIGHT", E.UIParent, "TOPRIGHT", E.mult, E.mult)
	topPanel:SetScript('OnShow', Panel_OnShow)
	topPanel:SetSize(E.UIParent:GetWidth() + (E.mult * 2), E.db.DTBars.datatexts.TopPanel.Height)
	topPanel:SetFrameStrata('BACKGROUND')
	topPanel:SetFrameLevel(0)
end

function DTB:createBottomPanel()

	
	bottomPanel:SetTemplate('Default', true)
	bottomPanel:SetFrameStrata('BACKGROUND')
	bottomPanel:SetFrameLevel(0)
	bottomPanel:SetSize(E.UIParent:GetWidth() + (E.mult * 2), E.db.DTBars.datatexts.BottomPanel.Height)
	bottomPanel:SetScript('OnShow', Panel_OnShow)	
	bottomPanel:SetPoint("BOTTOMLEFT", E.UIParent, "BOTTOMLEFT", -E.mult, -E.mult)
	bottomPanel:SetPoint("BOTTOMRIGHT", E.UIParent, "BOTTOMRIGHT", E.mult, -E.mult)

end

function DTB:PanelSetUp()

	local db = E.db.DTBars.datatexts
	for _,v in pairs(panels) do
		if db[v[2]].Enabled then
			v[1]:Show()
		else
			v[1]:Hide()
		end
	
	
		if db[v[2]].Transparent then
			v[1]:SetTemplate("Transparent")
		elseif db[v[2]].ClassColor then
			v[1]:SetTemplate("ClassColor");
		else
			v[1]:SetTemplate("Default", true)
		end
	end

end


local function Panel_OnShow(self)
	self:SetFrameLevel(0)
	self:SetFrameStrata('BACKGROUND')
end


function DTB:SetSize()
	topPanel:SetSize(E.UIParent:GetWidth() + (E.mult * 2), E.db.DTBars.datatexts.TopPanel.Height)
	bottomPanel:SetSize(E.UIParent:GetWidth() + (E.mult * 2), E.db.DTBars.datatexts.BottomPanel.Height)
end

function DTB:PetBattleHide()
	if E.db.DTBars.datatexts.TopPanel.PetHide then
		E.FrameLocks[topPanel] = true
	else
		E.FrameLocks[topPanel] = nil
	end
	
	if E.db.DTBars.datatexts.BottomPanel.PetHide then
		E.FrameLocks[bottomPanel] = true
	else
		E.FrameLocks[bottomPanel] = nil
	end

end



--_____________________________________________▄▄████████▄
--___________________________________________▄█▓▓▓█▓▓▓▓▓▓██▄
--___________________________________________█▓▓▓▓▓██▓▓▓▓▓▓▓█▄
--________________________________▄█████▄_█▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓█
--________________▄▄██████████▓▓▓▓▓▓▓██▓▓▓▓▓▓▓█▓▓▓▓▓▓▓██
--_____________▄█▓▓▓▓▓▓▓▓▓▓█▓██▓▓▓▓▓▓▓█▓▓▓▓▓█▓▓▓▓▓▓▓█▓█
--__________▄█▓▓▓▓▓▓▓▓▓▓▓▓█▓▓▓█▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓▓█▓▓█
--________▄█▓▓▓▓▓▓▓▓▓▓▓▓▓▓████▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓▓██▓▓█
--_______█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█▓▓▓███▓▓▓▓█
--______█▓▓▓▓▓▓▓▓▓▓▓▓███▀▀▀▀██▓▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓█▓▓▓▓█__▄████████▄
--_____█▓▓▓▓▓▓▓▓▓▓█▀▀___________▀█▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓█▓▓▓███▓▓▓▓▓▓▓▓▓▓█▄
--____█▓▓▓▓▓▓▓▓▓█▀_______________▓▓█▓▓▓▓███████▓███▓▓▓▓▓▓▓░░░▓▓▓▓▓▓▓▓▓█
--____█▓▓▓▓▓▓▓▓█_____________▓▓▓░░░█▓██░░░░░░░███▓▓▓▓▓▓░░░░░░▓▓▓▓▓▓▓▓▓▓█
--_____█▓▓▓▓▓▓█____________▓▓░░░░░░██░░░░░░░░░░░░███▓░░░░░░░░░▓▓▓▓▓▓▓▓▓▓█
--__█▌_█▓▓▓▓▓█___________▓░░░░░░░░░░░░░░░░░░░░░░░░▓░░░░░░░▓░░▓▓▓▓▓▓▓▓▓▓▓█
--_█▓█_█▓▓▓▓█__________▓▄▄░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░▓░░░▓▓▓▓▓▓▓▓▓▓▓█
--█▓▓▓██▓▓▓█_________▓█░░▐░░░░░░░░░▄█████▄░░░░░░░░░░░░░▓░░░░▓▓▓▓▓▓▓▓▓▓▓█
--█▓▓▓▓▓▓▓█________▀▄█░░░▐░░░░░░▄█▀░░░░░░▀█░░░░░░░░░░░▓░░░░▓▓▓▓█▓▓▓▓████
--_██▓▓▓██________▀▀▄▌░░░▐░░░░░░█░░░░░░░░░░█░░░░░░░░░▓░░░░░▓▓▓▓█▓███▓▓▓█
--___▀▀▀▀__________▀▄█░░░░▐░░░░░█░░░░░░░░░░░▐▌░░░░░░░▓░░░░░▓▓▓▓█▓▓▓▓▓▓▓█
--__________________▓░░▓▓▓▓░░░░░░█░░░░░░░░░░░░▐▄▄▄▅░░░░░░░░░▓████▓▓▓▓▓▓▓█
--_________________▓░░▀░░░░░░░░░░▀░░░░░░░░░░░░▐▀▄▄▅░░░░░░░░▓▓▓▓▓▓▓▓▓▓▓▓█
--__________________▓░░░░░░░░░░░░░░░░░░░░░░░░░░▀▄▄░░░░░░░░█▓▓▓▓▓▓▓▓▓▓▓█
--___________________▓░░░░░▓▓▓░░░░░░░░░░░░░░░░░░░░░███████▓▓▓▓▓▓▓▓▓▓▓█
--____________________▓▓▓▓▓▓▓▓░░░░░░░░░░░░░░░░░░░██▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓██
--_______________________▓▓▓▓▓░░░░░░░░░░░░░░░░░░█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓██████
--_______________________▓▓▓▓▓░░░░░░░░░░░░░░░░░█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█▓█
--_______________________▓▓▓▓▓░░░░░░░░░░░░░░░░░█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█▓▓█
--_______________________▓▒▒▓░░░░░░░░░░░░░░░░░░░█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█▓▓█
--_____________________▓▓▒▓░░░░░░░░░░░░░░░░░░░████████▓▓▓▓▓▓▓▓▓▓▓▓▓▓█▓▓█
--______________________▓▓▓▓▓░░░░░░░░░░░░░░███▓▓▓▓█▓▓▓██▓▓▓▓██▓▓▓▓▓█▓▓▓█
--_____________________________▓▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓▓▓█▓▓█▓▓▓▓█▓█████▓▓▓▓█
--___________________________________________█▓▓▓▓▓▓▓▓▓▓▓███▓▓▓▓█▓▓▓▓▓▓▓▓▓▓█
--__________________________________________█▓▓▓▓▓▓▓▓████▓▓▓▓▓▓█▓▓▓▓▓▓▓▓▓▓█
--_________________________________________█▓▓▓▓▓▓▓▓▓▓█▓▓██████▓▓▓▓▓▓▓▓▓█
--_________________________________________█▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓▓▓▓▓▓███
--__________________________________________█▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓███████
--___________________________________________█▓▓▓▓▓▓▓▓▓▓▓█▓▓▓▓▓█
--____________________________________________█▓▓▓▓▓▓▓▓▓█▓▓▓▓▓▓▓█
--__________________________________________███████████▓▓▓▓▓▓▓▓█
--_________________________________________█▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█
--________________________________________█▓▓▓▓▓██▓▓▓▓▓▓▓▓██
--_________________________________________█▓▓▓▓▓▓█▀▀▀▀▀▀▀
--___________________________________________██▓▓▓▓███▄▄
--______________________________________________▀▀▀▀▀



