local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')
local DTB = E:GetModule('DTBars')

local bars = {
	--Group name = {short name, order, slot}
	["Top Bar"] = {"Top_Bar", 1, 3},
	["Bottom Bar"] = {"Bottom_Bar", 2, 3},
	["Extra One"] = {"db1", 3, 3},
	["Extra Two"] = {"db2", 4, 3},
	["Extra Three"] = {"db3", 5, 3},
	["Extra Four"] = {"db4", 6, 3},
	["Extra Five"] = {"db5", 7, 3},
	["Extra Six"] = {"db6", 8, 3},
}



function DTB:addOptions()




E.Options.args.DTBars = {
	type = "group",
	name = "DTBars",
	order = 600,
	args = {
			header = {
				order = 1,
				type = "header",
				name = "ElvUI_DTBars",
			},
			info = {
				order = 2,
				type = "description",
				name = "DTBars Information",
			},
		
		topPanel = {
			order = 3,
			type = "group",
			name = "Top Panel",
			guiInline = true,
			args = {
				topEnable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.datatexts.TopPanel.Enabled end,
					set = function(info, value) E.db.DTBars.datatexts.TopPanel.Enabled = value; DTB:PanelSetUp() end
				},
				topHeight = {
					order = 2,
					type = "range",
					name = "Height",
					min = 1, max = 60, step = .5,
					get = function(info) return E.db.DTBars.datatexts.TopPanel.Height end,
					set = function(info, value) E.db.DTBars.datatexts.TopPanel.Height = value; DTB:SetSize() end
				},
				PetHide = {
					order = 3,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.datatexts.TopPanel.PetHide end,
					set = function(info, value) E.db.DTBars.datatexts.TopPanel.PetHide = value; DTB:PetBattleHide() end,
				},
				Transparent = {
					order = 4,
					type = "toggle",
					name = "Transparent",
					disabled = function() return not E.db.DTBars.datatexts.TopPanel.Enabled or E.db.DTBars.datatexts.TopPanel.ClassColor end,
					get = function(info) return E.db.DTBars.datatexts.TopPanel.Transparent end,
					set = function(info, value) E.db.DTBars.datatexts.TopPanel.Transparent = value; DTB:PanelSetUp() end,
				},
				ClassColor = {
					order = 5,
					type = 'toggle',
					name = "Class Color",
					disabled = function() return not E.db.DTBars.datatexts.TopPanel.Enabled or E.db.DTBars.datatexts.TopPanel.Transparent end,
					get = function(info) return E.db.DTBars.datatexts.TopPanel.ClassColor end,
					set = function(info, value) E.db.DTBars.datatexts.TopPanel.ClassColor = value; DTB:PanelSetUp() end,
				},
			},
		},
		bottomPanel = {
			order = 4,
			type = "group",
			name = "Bottom Panel",
			guiInline = true,
			args = {
				bottomEnable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.datatexts.BottomPanel.Enabled end,
					set = function(info, value) E.db.DTBars.datatexts.BottomPanel.Enabled = value; DTB:PanelSetUp() end
				},
				bottomHeight = {
					order = 2,
					type = "range",
					name = "Height",
					min = 1, max = 60, step = .5,
					get = function(info) return E.db.DTBars.datatexts.BottomPanel.Height end,
					set = function(info, value) E.db.DTBars.datatexts.BottomPanel.Height = value; DTB:SetSize() end
				},
				PetHide = {
					order = 3,
					type = "toggle",
					name = "Hide in Pet Battle",
					get = function(info) return E.db.DTBars.datatexts.BottomPanel.PetHide end,
					set = function(info, value) E.db.DTBars.datatexts.BottomPanel.PetHide = value; DTB:PetBattleHide() end,
				},
				Transparent = {
					order = 4,
					type = "toggle",
					name = "Transparent",
					disabled = function() return not E.db.DTBars.datatexts.BottomPanel.Enabled or E.db.DTBars.datatexts.BottomPanel.ClassColor end,
					get = function(info) return E.db.DTBars.datatexts.BottomPanel.Transparent end,
					set = function(info, value) E.db.DTBars.datatexts.BottomPanel.Transparent = value; DTB:PanelSetUp() end,
				},
				ClassColor = {
					order = 5,
					type = 'toggle',
					name = "Class Color",
					disabled = function() return not E.db.DTBars.datatexts.BottomPanel.Enabled or E.db.DTBars.datatexts.BottomPanel.Transparent end,
					get = function(info) return E.db.DTBars.datatexts.BottomPanel.ClassColor end,
					set = function(info, value) E.db.DTBars.datatexts.BottomPanel.ClassColor = value; DTB:PanelSetUp() end,
				},
			}
		},
		lchat = {
			order = 5,
			type = "group",
			name = "Left Tab",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.datatexts.LeftChatDataBar.Enabled end,
					set = function(info, value) E.db.DTBars.datatexts.LeftChatDataBar.Enabled = value; DTB:ShowTabs() end,
				}
			},
		},
		rchat = {
			order = 6,
			type = "group",
			name = "Right Tab",
			guiInline = true,
			args = {
				Enable = {
					order = 1,
					type = "toggle",
					name = "Enabled",
					get = function(info) return E.db.DTBars.datatexts.RightChatDataBar.Enabled end,
					set = function(info, value) E.db.DTBars.datatexts.RightChatDataBar.Enabled = value; DTB:ShowTabs() end,
				}
			},
		}
	}
}


E.Options.args.DTBars.args.datatext = {
	type = "group",
	name = L["Datatext Bars"],
	order = 1,
	childGroups = "select",
	args = {
		header = {
			order = 1,
			type = "header",
			name = L["Additional Datatext Bars"],
		},
	},
}



for k,v in pairs(bars) do
	E.Options.args.DTBars.args.datatext.args[v[1]] = {
		order = v[2],
		type = "group",
		name = k,
		get = function(info) return E.db.DTBars.datatexts[v[1]][ info[#info] ] end,
		args = {
			Enabled = {
				order = 1,
				type = "toggle",
				name = L["Enable"],
				desc = L["Show/Hide this bar."],
				set = function(info, value) E.db.DTBars.datatexts[v[1]].Enabled = value; DTB:ExtraDBSetup() end
			},
			Width = {
				order = 2,
				type = "range",
				name = L['Width'],
				desc = L["Sets size of this bar"],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				min = 25, max = E.screenwidth/2, step = 1,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].Width = value; DTB:Resize() end,
			},
			Hide = {
				order = 3,
				type = "toggle",
				name = L['Only Text'],
				desc = L["Hides the textures, just showing the datatext text."],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].Hide = value; E:StaticPopup_Show("PRIVATE_RL") end
			},
			Transparent = {
				order = 4,
				type = "toggle",
				name = L['Panel Transparency'],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled or E.db.DTBars.datatexts[v[1]].ClassColor end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].Transparent = value; DTB:ExtraDBSetup() end,	
			},
			ClassColor = {
				order = 5,
				type = "toggle",
				name = L['Class Color'],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled or E.db.DTBars.datatexts[v[1]].Transparent end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].ClassColor = value; DTB:ExtraDBSetup() end,
			},
			PetBattleHide = {
				order = 6,
				type = "toggle",
				name = L['Hide In Pet Battles'],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].PetBattleHide = value; DTB:RegisterHide() end,
			},
			MouseOver = {
				order = 7,
				type = "toggle",
				name = L['Mouseover'],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].MouseOver = value; DTB:MouseOver() end
			},
			CombatHide = {
				order = 8,
				type = "toggle",
				name = L['Hide in Combat'],
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].CombatHide = value; end
			},
			DataPlaces = {
				order = 9,
				type = "range",
				name = L['Number of Data Places'],
				min = 1, max = 5, step = 2,
				disabled = function() return not E.db.DTBars.datatexts[v[1]].Enabled end,
				set = function(info, value) E.db.DTBars.datatexts[v[1]].DataPlaces = value; E:StaticPopup_Show("PRIVATE_RL") end
			},
			
		},
	}
end
end

