local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB

local CURRENT_PAGE = 0
local MAX_PAGE = 5

SLASH_SKULL1, SLASH_SKULL2, SLASH_SKULL3 = '/sf', '/skull', '/skullflower';
function SlashCmdList.SKULL(msg, editbox)
	if msg == 'help' then
		 print('|cfffb4f4fSkullflower UI |cffffffffusage:');
		 print('/sf');
		 print('/sf reset');
		 print('/sf install');
		 print('/sf options');
	elseif msg == 'reset' then
		E:ResetUI()
	elseif msg == 'install' then
		E:Install();
	elseif msg == 'options' then
		E:Install();
	else
		E:Install();
	end
end

local function SetupChat()
	InstallStepComplete.message = L["Chat Set"]
	InstallStepComplete:Show()			
	FCF_ResetChatWindows()
	FCF_SetLocked(ChatFrame1, 1)
	FCF_DockFrame(ChatFrame2)
	FCF_SetLocked(ChatFrame2, 1)	

	FCF_OpenNewWindow(Trade)
	FCF_SetLocked(ChatFrame3, 1)
	ChatFrame3:Show()	
	
	FCF_OpenNewWindow(Private)
	FCF_SetLocked(ChatFrame4, 1)
	ChatFrame4:Show()	
			
	for i = 1, NUM_CHAT_WINDOWS do
		local frame = _G[format("ChatFrame%s", i)]
		local chatFrameId = frame:GetID()
		local chatName = FCF_GetChatWindowInfo(chatFrameId)
		
		FCF_SavePositionAndDimensions(frame)
		FCF_StopDragging(frame)
		
		-- set default Elvui font size
		FCF_SetChatWindowFontSize(nil, frame, 11, "OUTLINE")
		
		-- rename windows general because moved to chat #3
		if i == 1 then
			FCF_SetWindowName(frame, GENERAL)
		elseif i == 2 then
			FCF_SetWindowName(frame, GUILD_EVENT_LOG)
		elseif i == 3 then 
			FCF_SetWindowName(frame, TRADE) 
		elseif i == 4 then 
			FCF_SetWindowName(frame, "Private") 
		end
	end
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame1)
	ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_HORDE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_ALLIANCE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_NEUTRAL")
	ChatFrame_AddMessageGroup(ChatFrame1, "SYSTEM")
	ChatFrame_AddMessageGroup(ChatFrame1, "ERRORS")
	ChatFrame_AddMessageGroup(ChatFrame1, "AFK")
	ChatFrame_AddMessageGroup(ChatFrame1, "DND")
	ChatFrame_AddMessageGroup(ChatFrame1, "IGNORED")
	ChatFrame_AddMessageGroup(ChatFrame1, "ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_INLINE_TOAST_ALERT")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT_LEADER")	
	ChatFrame_AddMessageGroup(ChatFrame1, "LOOT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONEY")
	ChatFrame_AddMessageGroup(ChatFrame1, "CHANNEL")
	ChatFrame_AddMessageGroup(ChatFrame1, "SKILL")
	ChatFrame_AddMessageGroup(ChatFrame1, "CURRENCY ")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BOSS_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "CURRENCY")
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame4)
	ChatFrame_AddMessageGroup(ChatFrame4, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame4, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame4, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame4, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame4, "DND")
	ChatFrame_AddMessageGroup(ChatFrame4, "IGNORED")
	ChatFrame_AddMessageGroup(ChatFrame4, "ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame4, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame4, "BN_CONVERSATION")
	ChatFrame_AddMessageGroup(ChatFrame4, "BN_INLINE_TOAST_ALERT")
	ChatFrame_AddMessageGroup(ChatFrame4, "CHANNEL")
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame3)	
	ChatFrame_AddChannel(ChatFrame1, GENERAL)
	ChatFrame_RemoveChannel(ChatFrame1, L['Trade'])
	ChatFrame_AddChannel(ChatFrame3, L['Trade'])

	-- enable classcolor automatically on login and on each character without doing /configure each time.
	ToggleChatColorNamesByClassGroup(true, "SAY")
	ToggleChatColorNamesByClassGroup(true, "EMOTE")
	ToggleChatColorNamesByClassGroup(true, "YELL")
	ToggleChatColorNamesByClassGroup(true, "GUILD")
	ToggleChatColorNamesByClassGroup(true, "OFFICER")
	ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "WHISPER")
	ToggleChatColorNamesByClassGroup(true, "PARTY")
	ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID")
	ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
	ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT")	
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT_LEADER")	
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL6")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL7")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL8")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL9")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL10")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	
	--Adjust Chat Colors
	--General
	ChangeChatColor("CHANNEL1", 195/255, 230/255, 232/255)
	--Trade
	ChangeChatColor("CHANNEL2", 232/255, 158/255, 121/255)
	--Local Defense
	ChangeChatColor("CHANNEL3", 232/255, 228/255, 121/255)
end

local function SetupCVars()
	SetCVar("alternateResourceText", 1)
	SetCVar("statusTextDisplay", "BOTH")
	SetCVar("ShowClassColorInNameplate", 1)
	SetCVar("screenshotQuality", 10)
	SetCVar("chatMouseScroll", 1)
	SetCVar("chatStyle", "classic")
	SetCVar("WholeChatWindowClickable", 0)
	SetCVar("ConversationMode", "inline")
	SetCVar("showTutorials", 0)
	SetCVar("UberTooltips", 1)
	SetCVar("threatWarning", 3)
	SetCVar('alwaysShowActionBars', 1)
	SetCVar('lockActionBars', 1)
	SetCVar('SpamFilter', 0) --Blocks mmo-champion.com, dumb... ElvUI one is more effeciant anyways.
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:SetValue('SHIFT')
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:RefreshValue()
	InstallStepComplete.message = L["CVars Set"]
	InstallStepComplete:Show()					
end	

function E:GetColor(r, b, g, a)	
	return { r = r, b = b, g = g, a = a }
end

function E:SetupTheme(theme, noDisplayMsg)
	local classColor = RAID_CLASS_COLORS[E.myclass]
	E.private.theme = theme
	if not E.db.movers then E.db.movers = {}; end
		if theme == "SkullflowerUI" then
		InstallStepComplete.message = L["SkullflowerUI installed"]
		InstallStepComplete:Show()
		E.db.movers["MinimapMover"] = "TOPRIGHTElvUIParentTOPRIGHT-30-30"
		E.db.movers["BuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-182-31"
		E.db.movers["DebuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-182-151"
		E.db.movers["ElvUF_PlayerMover"] = "BOTTOMElvUIParentBOTTOM-182281"
		E.db.movers["PlayerPowerBarMover"] = "BOTTOMElvUIParentBOTTOM-182257"
		E.db.movers["ElvUF_PlayerCastbarMover"] = "BOTTOMElvUIParentBOTTOM0147"
		E.db.movers["AltPowerBarMover"] = "TOPElvUIParentTOP0-180"
		E.db.movers["ElvUF_PetMover"] = "BOTTOMElvUIParentBOTTOM-182233"
		E.db.movers["ElvUF_TargetMover"] = "BOTTOMElvUIParentBOTTOM182281"
		E.db.movers["TargetPowerBarMover"] = "BOTTOMElvUIParentBOTTOM182257"
		E.db.movers["ElvUF_TargetCastbarMover"] = "BOTTOMElvUIParentBOTTOM182256"
		E.db.movers["ElvUF_TargetTargetMover"] = "BOTTOMElvUIParentBOTTOM231206"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-504281"
		E.db.movers["ElvUF_FocusCastbarMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-504256"
		E.db.movers["LossControlMover"] = "TOPElvUIParentTOP0-490"
		E.db.movers["AlertFrameMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-255530"
		E.db.movers["BNETMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT30160"
		E.db.movers["LeftChatMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT304"
		E.db.movers["RightChatMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-304"
		E.db.movers["GMMover"] = "TOPLEFTElvUIParentTOPLEFT30-30"
		E.db.movers["CM_MOVER"] = "BOTTOMElvUIParentBOTTOM0150"
		E.db.movers["LootFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-255-529"
		E.db.movers["ExperienceBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-29-184"
		E.db.movers["ReputationBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-29-184"
		E.db.movers["TooltipMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-30323"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-3030"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-304"
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-3030"
		E.db.movers["ElvUF_AssistMover"] = "TOPLEFTElvUIParentTOPLEFT30-340"
		E.db.movers["ElvUF_TankMover"] = "TOPLEFTElvUIParentTOPLEFT30-240"
		E.db.movers["BossHeaderMover"] = "TOPLEFTElvUIParentTOPLEFT30-425"
		E.db.movers["WatchFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-30-300"
		E.db.movers["BossButton"] = "TOPElvUIParentTOP0-75"
		E.db.movers["ArenaHeaderMover"] = "TOPLEFTElvUIParentTOPLEFT30-375"
		E.db.movers["VehicleSeatMover"] = "TOPLEFTElvUIParentTOPLEFT30-30"
		E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM-182307"
		E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM-182307"
		E.db.movers["TotemBarMover"] = "BOTTOMElvUIParentBOTTOM16171"
		E.db.movers["ElvAB_1"] = "BOTTOMElvUIParentBOTTOM030"
		E.db.movers["ElvAB_2"] = "BOTTOMElvUIParentBOTTOM059"
		E.db.movers["ElvAB_3"] = "BOTTOMElvUIParentBOTTOM088"
		E.db.movers["ElvAB_4"] = "BOTTOMElvUIParentBOTTOM0117"
		E.db.movers["ElvAB_5"] = "BOTTOMElvUIParentBOTTOM01"
		E.db.movers["ShiftAB"] = "BOTTOMElvUIParentBOTTOM0146"
		E.db.movers["PetAB"] = "BOTTOMElvUIParentBOTTOM-182223"
		E.db.movers["MicrobarMover"] = "TOPLEFTElvUIParentTOPLEFT30-30"
		E.db.general.normTex = "Skullflower_Texture"
		E.db.general.glossTex = "Skullflower_Texture"
		E.db.general.dmgfont = "Expressway"
		E.db.general.namefont = "Expressway"
		E.db.general.font = "Expressway"
		E.db.general.bottomPanel = false
		E.db.general.fontSize = 11
		E.db.general.minimap.size = 150
		E.db.general.experience.width = 152
		E.db.general.experience.height = 15
		E.db.general.experience.orientation = "Horizontal"
		E.db.general.reputation.width = 152
		E.db.general.reputation.height = 15
		E.db.general.reputation.mouseover = false
		E.db.general.reputation.orientation = "Horizontal"
		E.db.general.threat.enable = false
		E.db.general.backdropcolor = { r = 65/255,g = 65/255,b = 65/255 }
		E.db.general.backdropfadecolor = { r = 18/255,g = 18/255,b = 18/255, a = 1.0}
		E.db.general.valuecolor = E:GetColor(classColor.r, classColor.b, classColor.g)
		E.db.general.totems.enable = true
		E.db.general.totems.growthDirection = "HORIZONTAL"
		E.db.auras.disableBlizzard = true
		E.db.unitframe.statusbar = "Skullflower_Texture"
		E.db.unitframe.font = "Expressway"
		E.db.unitframe.fontSize = 11
		E.db.unitframe.fontOutline = "OUTLINE"
		E.db.unitframe.debuffHighlighting = false
		E.db.unitframe.colors.healthclass = true
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.colors.castColor = E:GetColor(17/255, 17/255, 17/255)
		E.db.unitframe.colors.health = { r = 50/255, g = 250/255, b = 50/255 }
		E.db.unitframe.colors.health_backdrop = { r = 14/255,g = 14/255,b = 14/255 }
		E.db.unitframe.colors.tapped = { r = 195/255, g = 202/255, b = 217/255 }
		E.db.unitframe.colors.disconnected = { r = 195/255, g = 202/255, b = 217/255 }
		E.db.unitframe.colors.power.MANA = { r = 0/255,g = 190/255,b = 230/255 }
		E.db.unitframe.colors.power.RAGE = { r = 65/255,g = 65/255,b = 65/255 }
		E.db.unitframe.colors.power.FOCUS = { r = 230/255,g = 140/255,b = 60/255 }
		E.db.unitframe.colors.power.ENERGY = { r = 65/255,g = 65/255,b = 65/255 }
		E.db.unitframe.colors.power.RUNIC_POWER = { r = 65/255,g = 65/255,b = 65/255 }
		E.db.unitframe.colors.reaction.BAD = { r = 211/225, g = 27/225, b = 40/225 }
		E.db.unitframe.colors.reaction.NEUTRAL = { r = 255/255, g = 229/255, b = 58/255 }
		E.db.unitframe.colors.reaction.GOOD = { r = 80/255, g = 250/255, b = 71/255 }
		E.db.unitframe.colors.castClassColor = false
		E.db.unitframe.colors.customhealthbackdrop = true
		E.db.unitframe.colors.colorhealthbyvalue = true
		E.db.unitframe.units.player.customTexts = {}
		E.db.unitframe.units.player.customTexts.HealthText = {}
		E.db.unitframe.units.player.restIcon = false
		E.db.unitframe.units.player.width = 182
		E.db.unitframe.units.player.height = 24
		E.db.unitframe.units.player.healPrediction = false
		E.db.unitframe.units.player.threatStyle = "NONE"
		E.db.unitframe.units.player.health.text_format = ""
		E.db.unitframe.units.player.power.text_format = ""
		E.db.unitframe.units.player.power.height = 22
		E.db.unitframe.units.player.power.yOffset = -24
		E.db.unitframe.units.player.power.detachFromFrame = true
		E.db.unitframe.units.player.power.detachedWidth = 180
		E.db.unitframe.units.player.pvp.text_format = ""
		E.db.unitframe.units.player.buffs.enable = false
		E.db.unitframe.units.player.debuffs.enable = false
		E.db.unitframe.units.player.debuffs.sizeOverride = 54
		E.db.unitframe.units.player.debuffs.xOffset = -1
		E.db.unitframe.units.player.debuffs.yOffset = -14
		E.db.unitframe.units.player.debuffs.fontSize = 16
		E.db.unitframe.units.player.debuffs.attachTo = "Frame"
		E.db.unitframe.units.player.debuffs.anchorPoint = "LEFT"
		E.db.unitframe.units.player.castbar.enable = true
		E.db.unitframe.units.player.castbar.width = 231
		E.db.unitframe.units.player.castbar.height = 22
		E.db.unitframe.units.player.castbar.icon = false
		E.db.unitframe.units.player.castbar.latency = false
		E.db.unitframe.units.player.castbar.format = "Remaining"
		E.db.unitframe.units.player.castbar.ticks = true
		E.db.unitframe.units.player.castbar.spark = false
		if IsAddOnLoaded("CompactRunes") and E.myclass == "DEATHKNIGHT" then
			E.db.unitframe.units.player.classbar.enable = false
		else
			E.db.unitframe.units.player.classbar.enable = true
		end
		E.db.unitframe.units.player.classbar.detachFromFrame = true
		E.db.unitframe.units.player.classbar.detachedWidth = 182
		E.db.unitframe.units.player.classbar.height = 15
		E.db.unitframe.units.player.aurabar.enable = false
		E.db.unitframe.units.player.stagger.enable = false
		E.db.unitframe.units.player.customTexts.HealthText.justifyH = "Left"
		E.db.unitframe.units.player.customTexts.HealthText.xOffset = 11
		E.db.unitframe.units.player.customTexts.HealthText.yOffset = -11
		E.db.unitframe.units.player.customTexts.HealthText.size = 32
		E.db.unitframe.units.target.customTexts = {}
		E.db.unitframe.units.target.customTexts.HealthText = {}
		E.db.unitframe.units.target.rangeCheck = false
		E.db.unitframe.units.target.width = 182
		E.db.unitframe.units.target.height = 24
		E.db.unitframe.units.target.healPrediction = false
		E.db.unitframe.units.target.threatStyle = "NONE"
		E.db.unitframe.units.target.health.text_format = ""
		E.db.unitframe.units.target.power.text_format = ""
		E.db.unitframe.units.target.power.position = "LEFT"
		E.db.unitframe.units.target.power.height = 22
		E.db.unitframe.units.target.power.xOffset = 0
		E.db.unitframe.units.target.power.yOffset = -24
		E.db.unitframe.units.target.power.detachFromFrame = true
		E.db.unitframe.units.target.power.detachedWidth = 180
		E.db.unitframe.units.target.power.hideonnpc = false
		E.db.unitframe.units.target.name.position = "LEFT"
		E.db.unitframe.units.target.name.text_format = "[name:medium]"
		E.db.unitframe.units.target.name.xOffset = 0
		E.db.unitframe.units.target.name.yOffset = 0
		E.db.unitframe.units.target.buffs.enable = true
		E.db.unitframe.units.target.buffs.anchorPoint = "TOPLEFT"
		E.db.unitframe.units.target.buffs.fontSize = 11
		E.db.unitframe.units.target.buffs.yOffset = 2
		E.db.unitframe.units.target.debuffs.enable = true
		E.db.unitframe.units.target.debuffs.attachTo = "FRAME"
		E.db.unitframe.units.target.debuffs.anchorPoint = "BOTTOMLEFT"
		E.db.unitframe.units.target.debuffs.fontSize = 11
		E.db.unitframe.units.target.debuffs.yOffset = -26
		E.db.unitframe.units.target.combobar.enable = true
		E.db.unitframe.units.target.combobar.height = 15
		E.db.unitframe.units.target.combobar.detachFromFrame = true
		E.db.unitframe.units.target.combobar.detachedWidth = 180
		E.db.unitframe.units.target.combobar.autoHide = true
		E.db.unitframe.units.target.castbar.enable = true
		E.db.unitframe.units.target.castbar.width = 182
		E.db.unitframe.units.target.castbar.height = 22
		E.db.unitframe.units.target.castbar.icon = false
		E.db.unitframe.units.target.castbar.format = "Remaining"
		E.db.unitframe.units.target.castbar.spark = false
		E.db.unitframe.units.target.aurabar.enable = false
		E.db.unitframe.units.target.customTexts.HealthText.justifyH = "Right"
		E.db.unitframe.units.target.customTexts.HealthText.xOffset = -11
		E.db.unitframe.units.target.customTexts.HealthText.yOffset = -11
		E.db.unitframe.units.target.customTexts.HealthText.size = 32
		E.db.unitframe.units.targettarget.enable = false
		E.db.unitframe.units.targettarget.rangeCheck = false
		E.db.unitframe.units.targettarget.debuffs.enable = false
		E.db.unitframe.units.targettarget.width = 85
		E.db.unitframe.units.targettarget.height = 25
		E.db.unitframe.units.targettarget.power.enable = false
		E.db.unitframe.units.targettarget.name.position = "CENTER"
		E.db.unitframe.units.targettarget.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.focus.rangeCheck = false
		E.db.unitframe.units.focus.width = 182
		E.db.unitframe.units.focus.height = 24
		E.db.unitframe.units.focus.power.enable = true
		E.db.unitframe.units.focus.power.height = 3
		E.db.unitframe.units.focus.threatStyle = "NONE"
		E.db.unitframe.units.focus.name.position = "CENTER"
		E.db.unitframe.units.focus.name.text_format = "[name]"
		E.db.unitframe.units.focus.debuffs.enable = false
		E.db.unitframe.units.focus.castbar.width = 182
		E.db.unitframe.units.focus.castbar.height = 22
		E.db.unitframe.units.focus.castbar.icon = false
		E.db.unitframe.units.focus.castbar.format = "Remaining"
		E.db.unitframe.units.focus.castbar.spark = false
		E.db.unitframe.units.pet.rangeCheck = false
		E.db.unitframe.units.pet.width = 182
		E.db.unitframe.units.pet.height = 22
		E.db.unitframe.units.pet.threatStyle = "NONE"
		E.db.unitframe.units.pet.healPrediction = false
		E.db.unitframe.units.pet.power.enable = false
		E.db.unitframe.units.pet.name.text_format = ""
		E.db.unitframe.units.pet.buffIndicator.enable = false
		E.db.unitframe.units.boss.width = 175
		E.db.unitframe.units.boss.height = 30
		E.db.unitframe.units.boss.health.text_format = "[health:percent]"
		E.db.unitframe.units.boss.health.position = "RIGHT"
		E.db.unitframe.units.boss.power.enable = false
		E.db.unitframe.units.boss.name.text_format = "[name:medium]"
		E.db.unitframe.units.boss.buffs.enable = false
		E.db.unitframe.units.boss.debuffs.enable = false
		E.db.unitframe.units.boss.castbar.enable = false
		E.db.unitframe.units.arena.width = 225
		E.db.unitframe.units.arena.height = 40
		E.db.unitframe.units.arena.health.text_format = "[health:current]"
		E.db.unitframe.units.arena.power.text_format = ""
		E.db.unitframe.units.arena.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.arena.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.arena.buffs.fontSize = 11
		E.db.unitframe.units.arena.buffs.sizeOverride = 18
		E.db.unitframe.units.arena.buffs.xOffset = 2
		E.db.unitframe.units.arena.buffs.yOffset = 10
		E.db.unitframe.units.arena.debuffs.fontSize = 11
		E.db.unitframe.units.arena.debuffs.sizeOverride = 18
		E.db.unitframe.units.arena.debuffs.xOffset = 2
		E.db.unitframe.units.arena.debuffs.yOffset = -10
		E.db.unitframe.units.arena.castbar.width = 225
		E.db.unitframe.units.arena.castbar.height = 10
		E.db.unitframe.units.arena.castbar.icon = false
		E.db.unitframe.units.arena.castbar.format = ""
		E.db.unitframe.units.arena.castbar.spark = false
		E.db.unitframe.units.party.width = 50
		E.db.unitframe.units.party.height = 30
		E.db.unitframe.units.raid.width = 50
		E.db.unitframe.units.raid.height = 25
		E.db.unitframe.units.raid40.width = 50
		E.db.unitframe.units.raid40.height = 25
		E.db.unitframe.units.party.threatStyle = "NONE"
		E.db.unitframe.units.party.growthDirection = "LEFT_DOWN"
		E.db.unitframe.units.party.horizontalSpacing = 1
		E.db.unitframe.units.party.verticalSpacing = 1
		E.db.unitframe.units.party.health.text_format = ""
		E.db.unitframe.units.party.power.enable = false
		E.db.unitframe.units.party.name.position = "CENTER"
		E.db.unitframe.units.party.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.GPSArrow.enable = false
		E.db.unitframe.units.party.buffIndicator.enable = false
		E.db.unitframe.units.party.roleIcon.enable = false
		E.db.unitframe.units.party.debuffs.perrow = 1
		E.db.unitframe.units.party.debuffs.numrows = 3
		E.db.unitframe.units.party.debuffs.sizeOverride = 30
		E.db.unitframe.units.party.debuffs.yOffset = -1
		E.db.unitframe.units.party.debuffs.anchorPoint = "BOTTOM"
		E.db.unitframe.units.party.debuffs.onlyDispellable = true
		E.db.unitframe.units.party.buffs.perrow = 2
		E.db.unitframe.units.party.buffs.numrows = 1
		E.db.unitframe.units.party.buffs.sizeOverride = 20
		E.db.unitframe.units.party.buffs.xOffset = -47
		E.db.unitframe.units.party.buffs.yOffset = 0
		E.db.unitframe.units.party.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.raid.threatStyle = "NONE"
		E.db.unitframe.units.raid.growthDirection = "LEFT_DOWN"
		E.db.unitframe.units.raid.horizontalSpacing = 1
		E.db.unitframe.units.raid.verticalSpacing = 1
		E.db.unitframe.units.raid.health.text_format = ""
		E.db.unitframe.units.raid.power.enable = false
		E.db.unitframe.units.raid.name.position = "CENTER"
		E.db.unitframe.units.raid.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.raid.GPSArrow.enable = false
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid40.threatStyle = "NONE"
		E.db.unitframe.units.raid40.growthDirection = "LEFT_DOWN"
		E.db.unitframe.units.raid40.horizontalSpacing = 1
		E.db.unitframe.units.raid40.verticalSpacing = 1
		E.db.unitframe.units.raid40.health.text_format = ""
		E.db.unitframe.units.raid40.power.enable = false
		E.db.unitframe.units.raid40.name.position = "CENTER"
		E.db.unitframe.units.raid40.name.text_format = "[name:veryshort]"
		E.db.unitframe.units.raid40.GPSArrow.enable = false
		E.db.unitframe.units.raid40.roleIcon.enable = false
		E.db.unitframe.units.tank.enable = false
		E.db.unitframe.units.assist.enable = false
		E.db.unitframe.units.boss.enable = false
		E.db.bags.bagSize = 31
		E.db.bags.bankSize = 31
		E.db.nameplate.font = "Expressway"
		E.db.nameplate.fontSize = 8
		E.db.nameplate.fontOutline = "OUTLINE"
		E.db.nameplate.targetIndicator = false
		E.db.nameplate.healthBar.width = 100
		E.db.nameplate.healthBar.height = 8
		E.db.nameplate.healthBar.text.enable = false
		E.db.nameplate.buffs.font = "Expressway"
		E.db.nameplate.buffs.fontOutline = "OUTLINE"
		E.db.nameplate.debuffs.font = "Expressway"
		E.db.nameplate.debuffs.fontOutline = "OUTLINE"
		E.db.nameplate.threat.goodColor = {r = 88/255, g = 255/255, b = 105/255}
		E.db.nameplate.threat.badColor = {r = 251/255, g = 9/255, b = 27/255}
		E.db.nameplate.threat.goodTransitionColor = {r = 88/255, g = 255/255, b = 105/255}
		E.db.nameplate.threat.badTransitionColor = {r = 251/255, g = 9/255, b = 27/255}
		E.db.nameplate.reactions.tapped = {r = 195/255, g = 202/255, b = 217/255}
		E.db.nameplate.reactions.friendlyNPC = { r = 80/255, g = 250/255, b = 71/255 }
		E.db.nameplate.reactions.friendlyPlayer = { r = 80/255, g = 250/255, b = 71/255 }
		E.db.nameplate.reactions.neutral = { r = 255/255, g = 229/255, b = 58/255 }
		E.db.nameplate.reactions.enemy = { r = 211/225, g = 27/225, b = 40/225 }
		E.db.auras.font = "Expressway"
		E.db.auras.fontSize = 11
		E.db.auras.fontOutline = "OUTLINE"
		E.db.auras.consolidatedBuffs.enable = false
		E.db.auras.consolidatedBuffs.font = "Expressway"
		E.db.auras.consolidatedBuffs.fontSize = 10
		E.db.auras.consolidatedBuffs.fontOutline = "OUTLINE"
		E.db.auras.buffs.wrapAfter = 20
		E.db.auras.buffs.maxWraps = 1
		E.db.auras.buffs.horizontalSpacing = 1
		E.db.auras.buffs.verticalSpacing = 16
		E.db.auras.buffs.size = 32
		E.db.auras.debuffs.horizontalSpacing = 1
		E.db.auras.debuffs.wrapAfter = 20
		E.db.auras.debuffs.size = 32
		E.db.chat.font = "Expressway"
		E.db.chat.fontOutline = "OUTLINE"
		E.db.chat.emotionIcons = false
		E.db.chat.panelWidth = 350
		E.db.chat.panelHeight = 150
		E.db.chat.panelBackdrop = "HIDEBOTH"
		E.db.chat.panelTabBackdrop = false
		E.db.chat.tabFont = "Expressway"
		E.db.chat.tabFontSize = 11
		E.db.chat.tabFontOutline = "OUTLINE"
		E.db.chat.lfgIcons = false
		E.db.datatexts.font = "Expressway"
		E.db.datatexts.fontSize = 11
		E.db.datatexts.fontOutline = "OUTLINE"
		E.db.datatexts.panels.LeftChatDataPanel.left = ""
		E.db.datatexts.panels.LeftChatDataPanel.middle = ""
		E.db.datatexts.panels.LeftChatDataPanel.right = ""
		E.db.datatexts.panels.RightChatDataPanel.left = ""
		E.db.datatexts.panels.RightChatDataPanel.middle = ""
		E.db.datatexts.panels.RightChatDataPanel.right = ""
		E.db.datatexts.panels.LeftMiniPanel = ""
		E.db.datatexts.panels.RightMiniPanel = "Time"
		E.db.datatexts.battleground = false
		E.db.tooltip.cursorAnchor = false
		E.db.tooltip.targetInfo = false
		E.db.tooltip.playerTitles = false
		E.db.tooltip.inspectInfo = false
		E.db.tooltip.guildRanks = false
		E.db.tooltip.talentInfo = false
		E.db.tooltip.itemCount = false
		E.db.tooltip.spellID = false
		E.db.tooltip.healthBar.height = 0
		E.db.tooltip.healthBar.font = "Expressway"
		E.db.tooltip.healthBar.text = false
		E.db.cooldown.threshold = -1
		E.db.cooldown.expiringcolor = { r = 251/255, g = 9/255, b = 27/255 }
		E.db.cooldown.secondscolor = { r = 253/255, g = 255/255, b = 96/255 }
		E.db.cooldown.minutescolor = { r = 1, g = 1, b = 1 }
		E.db.cooldown.hourscolor = { r = 108/225, g = 192/225, b = 229/225 }
		E.db.cooldown.dayscolor = { r = 108/225, g = 192/225, b = 229/225 }
		E.db.actionbar.font = "Expressway"
		E.db.actionbar.fontSize = 11
		E.db.actionbar.fontOutline = "OUTLINE"
		E.db.actionbar.hotkeytext = false
		E.db.actionbar.noRangeColor = {r = 251/255, g = 9/255, b = 27/255}
		E.db.actionbar.noPowerColor = {r = 63/255, g = 88/255, b = 255/255}
		E.db.actionbar.microbar.enabled = true
		E.db.actionbar.microbar.mouseover = true
		E.db.actionbar.bar1.buttons = 8
		E.db.actionbar.bar1.buttonsPerRow = 8
		E.db.actionbar.bar1.buttonsize = 28
		E.db.actionbar.bar1.buttonspacing = 1
		E.db.actionbar.bar2.enabled = true
		E.db.actionbar.bar2.buttons = 8
		E.db.actionbar.bar2.buttonsPerRow = 8
		E.db.actionbar.bar2.buttonsize = 28
		E.db.actionbar.bar2.buttonspacing = 1
		E.db.actionbar.bar3.mouseover = true
		E.db.actionbar.bar3.buttons = 8
		E.db.actionbar.bar3.buttonsPerRow = 12
		E.db.actionbar.bar3.buttonsize = 28
		E.db.actionbar.bar3.buttonspacing = 1
		E.db.actionbar.bar3.alpha = 0.25
		E.db.actionbar.bar4.mouseover = true
		E.db.actionbar.bar4.buttons = 8
		E.db.actionbar.bar4.point = "BOTTOMLEFT"
		E.db.actionbar.bar4.buttonsPerRow = 12
		E.db.actionbar.bar4.backdrop = false
		E.db.actionbar.bar4.buttonsize = 28
		E.db.actionbar.bar4.buttonspacing = 1
		E.db.actionbar.bar4.alpha = 0.25
		E.db.actionbar.bar5.mouseover = true
		E.db.actionbar.bar5.buttons = 12
		E.db.actionbar.bar5.buttonsPerRow = 12
		E.db.actionbar.bar5.buttonsize = 28
		E.db.actionbar.bar5.buttonspacing = 1
		E.db.actionbar.bar5.alpha = 0.25
		E.db.actionbar.bar6.enabled = false
		E.db.actionbar.bar6.buttons = 8
		E.db.actionbar.bar6.buttonsize = 28
		E.db.actionbar.bar6.buttonspacing = 1
		E.db.actionbar.barPet.mouseover = true
		E.db.actionbar.barPet.buttonsize = 17
		E.db.actionbar.barPet.buttonsPerRow = 10
		E.db.actionbar.barPet.buttonspacing = 1
		E.db.actionbar.stanceBar.mouseover = true
		E.db.actionbar.stanceBar.buttonsize = 28
		E.db.actionbar.stanceBar.buttonspacing = 1
	elseif theme == "dataT" then
		E.db.movers["RightChatMover"] = "BOTTOMElvUIParentBOTTOM564"
		E.db.datatexts.panels.RightChatDataPanel.left = "System"
		E.db.datatexts.panels.RightChatDataPanel.middle = "Gold"
	elseif theme == "healF" then
		InstallStepComplete.message = L["Heal Layout set"]
		InstallStepComplete:Show()
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT263424"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-304"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT288424"
		E.db.movers["ElvUF_PartyMover"] = "TOPLEFTElvUIParentTOPLEFT322-520"
		E.db.unitframe.units.raid.width = 60
		E.db.unitframe.units.raid.height = 35
		E.db.unitframe.units.raid40.width = 60
		E.db.unitframe.units.raid40.height = 35
		E.db.unitframe.units.party.width = 55
		E.db.unitframe.units.party.height = 40
		E.db.unitframe.units.party.debuffs.enable = true
	elseif theme == "cBuffs" then
	InstallStepComplete.message = L["Consolidated Buffs enabled"]
	InstallStepComplete:Show()
		E.db.auras.consolidatedBuffs.enable = true
		E.db.movers["DebuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-209-151"
		E.db.movers["BuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-209-31"
		E.db.movers["ExperienceBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-30-184"
		E.db.movers["ReputationBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-30-184"
		E.db.general.experience.width = 172
		E.db.general.reputation.width = 172
	elseif theme == "unhideB" then
	InstallStepComplete.message = L["Buttons unhidden"]
	InstallStepComplete:Show()
		E.db.actionbar.bar3.mouseover = false
		E.db.actionbar.bar4.mouseover = false
	elseif theme == "sqAB" then
	InstallStepComplete.message = L["Square ActionBar set"]
	InstallStepComplete:Show()
		E.db.movers["ElvAB_2"] = "BOTTOMElvUIParentBOTTOM088"
		E.db.movers["ElvAB_3"] = "BOTTOMElvUIParentBOTTOM-11630"
		E.db.movers["ElvAB_4"] = "BOTTOMElvUIParentBOTTOM11630"
		E.db.actionbar.bar1.buttons = 12
		E.db.actionbar.bar1.buttonsPerRow = 6
		E.db.actionbar.bar2.buttons = 12
		E.db.actionbar.bar2.buttonsPerRow = 6
		E.db.actionbar.bar3.buttons = 8
		E.db.actionbar.bar3.buttonsPerRow = 2
		E.db.actionbar.bar4.buttons = 8
		E.db.actionbar.bar4.buttonsPerRow = 2
		E.db.unitframe.units.player.castbar.width = 173
	elseif theme == "unitT" then
	InstallStepComplete.message = L["Unitframe texts enabled"]
	InstallStepComplete:Show()
		E.db.unitframe.units.player.customTexts.HealthText.text_format = "[health:current]"
		E.db.unitframe.units.target.customTexts.HealthText.text_format = "[health:current]"
		E.db.unitframe.units.player.power.text_format = "[power:current]"
		E.db.unitframe.units.target.power.text_format = "[health:percent]"
	elseif theme == "altUF" then
		InstallStepComplete.message = L["Alternate Unitframes enabled"]
		InstallStepComplete:Show()
		E.db.movers["PlayerPowerBarMover"] = "BOTTOMElvUIParentBOTTOM-182266"
		E.db.movers["ElvUF_PetMover"] = "BOTTOMElvUIParentBOTTOM-182242"
		E.db.movers["TargetPowerBarMover"] = "BOTTOMElvUIParentBOTTOM182266"
		E.db.movers["ElvUF_TargetCastbarMover"] = "BOTTOMElvUIParentBOTTOM182265"
		E.db.movers["ElvUF_TargetTargetMover"] = "BOTTOMElvUIParentBOTTOM233215"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-498281"
		E.db.movers["ElvUF_FocusCastbarMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-498265"
		E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM-182313"
		E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM-182313"
		E.db.unitframe.statusbar = "Skullflower_Neon"
		E.db.unitframe.units.player.width = 186
		E.db.unitframe.units.player.height = 30
		E.db.unitframe.units.player.power.height = 15
		E.db.unitframe.units.player.power.detachedWidth = 184
		E.db.unitframe.units.player.classbar.detachedWidth = 186
		E.db.unitframe.units.player.debuffs.sizeOverride = 46
		E.db.unitframe.units.player.debuffs.yOffset = -8
		E.db.unitframe.units.target.width = 186
		E.db.unitframe.units.target.height = 30
		E.db.unitframe.units.target.power.height = 15
		E.db.unitframe.units.target.power.detachedWidth = 184
		E.db.unitframe.units.target.combobar.detachedWidth = 184
		E.db.unitframe.units.target.debuffs.yOffset = -17
		E.db.unitframe.units.target.castbar.width = 186
		E.db.unitframe.units.target.castbar.height = 15
		E.db.unitframe.units.focus.width = 186
		E.db.unitframe.units.focus.height = 30
		E.db.unitframe.units.focus.castbar.width = 186
		E.db.unitframe.units.focus.castbar.height = 13
		E.db.unitframe.units.pet.width = 186
		E.db.unitframe.units.player.power.yOffset = -22
		E.db.unitframe.units.target.power.yOffset = -22
	elseif theme == "eToT" then
	InstallStepComplete.message = L["ToT frame enabled"]
	InstallStepComplete:Show()
		E.db.unitframe.units.targettarget.enable = true
	elseif theme == "Gradient" then
		E.db.unitframe.statusbar = "Skullflower_Gradient"
	elseif theme == "Basic" then
		E.db.unitframe.statusbar = "Skullflower_Texture"
	elseif theme == "Neon" then
		E.db.unitframe.statusbar = "Skullflower_Neon"
	elseif theme == "resetTheme" then
	InstallStepComplete.message = L["Settings reset"]
	InstallStepComplete:Show()
		E.db.movers["MinimapMover"] = "TOPRIGHTElvUIParentTOPRIGHT-30-30"
		E.db.movers["BuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-182-31"
		E.db.movers["PlayerPowerBarMover"] = "BOTTOMElvUIParentBOTTOM-182257"
		E.db.movers["ElvUF_PlayerCastbarMover"] = "BOTTOMElvUIParentBOTTOM0147"
		E.db.movers["ElvUF_PetMover"] = "BOTTOMElvUIParentBOTTOM-182233"
		E.db.movers["TargetPowerBarMover"] = "BOTTOMElvUIParentBOTTOM182257"
		E.db.movers["ElvUF_TargetCastbarMover"] = "BOTTOMElvUIParentBOTTOM182256"
		E.db.movers["ElvUF_TargetTargetMover"] = "BOTTOMElvUIParentBOTTOM231206"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-504281"
		E.db.movers["ElvUF_FocusCastbarMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-504256"
		E.db.movers["ElvAB_2"] = "BOTTOMElvUIParentBOTTOM059"
		E.db.movers["ElvAB_3"] = "BOTTOMElvUIParentBOTTOM088"
		E.db.movers["ElvAB_4"] = "BOTTOMElvUIParentBOTTOM0117"
		E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM-182307"
		E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM-182307"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-3030"
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-3030"
		E.db.movers["ExperienceBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-29-184"
		E.db.movers["ReputationBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-29-184"
		E.db.movers["RightChatMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-304"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-304"
		E.db.general.experience.width = 152
		E.db.general.reputation.width = 152
		E.db.datatexts.panels.RightChatDataPanel.left = ""
		E.db.datatexts.panels.RightChatDataPanel.middle = ""
		E.db.auras.consolidatedBuffs.enable = false
		E.db.unitframe.units.player.width = 182
		E.db.unitframe.units.player.height = 24
		E.db.unitframe.units.player.power.height = 22
		E.db.unitframe.units.player.power.detachedWidth = 180
		E.db.unitframe.units.player.classbar.detachedWidth = 182
		E.db.unitframe.units.player.debuffs.sizeOverride = 54
		E.db.unitframe.units.player.debuffs.yOffset = -14
		E.db.unitframe.units.player.customTexts.HealthText.text_format = ""
		E.db.unitframe.units.player.power.text_format = ""
		E.db.unitframe.units.target.power.text_format = ""
		E.db.unitframe.units.player.power.yOffset = -24
		E.db.unitframe.units.target.power.yOffset = -24
		E.db.unitframe.units.player.castbar.width = 231
		E.db.unitframe.units.target.castbar.width = 182
		E.db.unitframe.units.target.castbar.height = 22
		E.db.unitframe.units.pet.width = 182
		E.db.unitframe.units.target.width = 182
		E.db.unitframe.units.target.height = 24
		E.db.unitframe.units.target.power.height = 22
		E.db.unitframe.units.target.power.detachedWidth = 180
		E.db.unitframe.units.target.combobar.detachedWidth = 180
		E.db.unitframe.units.target.debuffs.yOffset = -26
		E.db.unitframe.units.target.customTexts.HealthText.text_format = ""
		E.db.unitframe.units.target.power.text_format = ""
		E.db.unitframe.units.targettarget.enable = false
		E.db.unitframe.units.focus.width = 182
		E.db.unitframe.units.focus.height = 24
		E.db.unitframe.units.focus.castbar.width = 182
		E.db.unitframe.units.focus.castbar.height = 22
		E.db.unitframe.units.party.width = 50
		E.db.unitframe.units.party.height = 30
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.buffs.enable = false
		E.db.unitframe.units.raid.width = 50
		E.db.unitframe.units.raid.height = 25
		E.db.unitframe.units.raid40.width = 50
		E.db.unitframe.units.raid40.height = 25
		E.db.actionbar.bar1.buttonsPerRow = 12
		E.db.actionbar.bar1.buttons = 8
		E.db.actionbar.bar2.buttonsPerRow = 12
		E.db.actionbar.bar2.buttons = 8
		E.db.actionbar.bar3.buttonsPerRow = 12
		E.db.actionbar.bar3.buttons = 8
		E.db.actionbar.bar3.mouseover = true
		E.db.actionbar.bar4.mouseover = true
		E.db.actionbar.bar4.buttonsPerRow = 12
		E.db.actionbar.bar4.buttons = 8
		E.db.unitframe.statusbar = "Skullflower_Texture"
	end
	
	if not noDisplayMsg then
		E:UpdateAll(true)
	end
end

function E:SetupAddon(addon)
	if addon == 'Skada' then
		if IsAddOnLoaded('Skada') then
			E:Print(L["A profile for Skada has been created."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			SkadaDB['profiles']['Skullflower'] = {
				["icon"] = {
					["hide"] = true,
				},
				["tooltiprows"] = 5,
				["showranks"] = false,
				["hidedisables"] = false,
				["tooltippos"] = "topleft",
				["windows"] = {
					{
						["classicons"] = false,
					["barslocked"] = true,
					["background"] = {
						["height"] = 125.0000381469727,
					},
					["y"] = 31.99955558776856,
					["barfont"] = "Expressway",
					["title"] = {
						["color"] = {
							["a"] = 1,
							["r"] = 0.1019607843137255,
							["g"] = 0.1019607843137255,
							["b"] = 0.3019607843137255,
						},
						["font"] = "Expressway",
						["fontflags"] = "OUTLINE",
						["texture"] = "Skullflower",
					},
					["barfontflags"] = "OUTLINE",
					["barcolor"] = {
						["r"] = 0.8392156862745098,
						["g"] = 0.9215686274509803,
						["b"] = 1,
					},
					["mode"] = "Damage",
					["buttons"] = {
						["report"] = false,
						["menu"] = false,
						["mode"] = false,
						["segment"] = false,
						["reset"] = false,
					},
					["bartexture"] = "Skullflower_Texture",
					["barwidth"] = 208.9998626708984,
					["point"] = "BOTTOMRIGHT",
					["barbgcolor"] = {
						["a"] = 1,
						["r"] = 0.3019607843137255,
						["g"] = 0.3019607843137255,
						["b"] = 0.3019607843137255,
					},
					["barfontsize"] = 10,
					["enabletitle"] = false,
					["x"] = -286.9990234375,
					}, -- [2]
				},
			}
		else
			E:Print(L["The AddOn Skada is not enabled. Profile not created."])
		end
		
		if IsAddOnLoaded('CompactRunes') then
			E:Print(L["A profile for CompactRunes has been created."])
			InstallStepComplete:Show()
			CompactRunesDB['profiles']['Skullflower'] = {
			["ooc_alpha"] = 0,
			["profileVersion"] = 2,
			["font_size"] = 11,
			["runeOrder"] = "UFB",
			["rangeInd"] = false,
			["border"] = "Pixel",
			["texture"] = "Skullflower_Texture",
			["frame"] = {
				["y"] = -258.9999389648438,
				["x"] = 7.00018310546875,
			},
			["trackDiseases"] = false,
			["width"] = 28,
			["bars"] = {
				["BloodPlagueBar"] = {
				},
				["RunicPowerBar"] = {
					["enabled"] = false,
				},
				["FrostFeverBar"] = {
				},
				["BloodShieldBar"] = {
				},
			},
			["priorityList"] = {
				["Unholy"] = {
					"Soul Reaper", -- [1]
					"Sudden Doom", -- [2]
					"Plague Leech", -- [3]
					"Summon Gargoyle", -- [4]
					"Unholy Frenzy", -- [5]
					"Blood Charge", -- [6]
					"Dark Succor", -- [7]
				},
			},
			["cdbars"] = {
				["Unholy"] = {
					["ordering"] = {
						"Summon Gargoyle", -- [1]
						"Unholy Frenzy", -- [2]
						"Anti-Magic Shell", -- [3]
						"Outbreak", -- [4]
						"Empower Rune Weapon", -- [5]
						"Army of the Dead", -- [6]
						"Thok's Tail Tip", -- [7]
						"Fabled Feather of Ji-Kun", -- [8]
						"Brutal Talisman of the Shado-Pan Assault", -- [9]
						"Fusion-Fire Core", -- [10]
						"Evil Eye of Galakras", -- [11]
					},
				},
				["Frost"] = {
					["ordering"] = {
						"Pillar of Frost", -- [1]
						"Outbreak", -- [2]
						"Anti-Magic Shell", -- [3]
						"Empower Rune Weapon", -- [4]
						"Army of the Dead", -- [5]
						"Thok's Tail Tip", -- [6]
						"Brutal Talisman of the Shado-Pan Assault", -- [7]
						"Fabled Feather of Ji-Kun", -- [8]
						"Fusion-Fire Core", -- [9]
						"Evil Eye of Galakras", -- [10]
					},
				},
				["Blood"] = {
					["ordering"] = {
						"Rune Tap", -- [1]
						"Vampiric Blood", -- [2]
						"Anti-Magic Shell", -- [3]
						"Outbreak", -- [4]
						"Dancing Rune Weapon", -- [5]
						"Death Pact", -- [6]
						"Icebound Fortitude", -- [7]
						"Empower Rune Weapon", -- [8]
						"Army of the Dead", -- [9]
						"Steadfast Talisman of the Shado-Pan Assault", -- [10]
						"Fortitude of the Zandalari", -- [11]
					},
				},
			},
			}
		else
			E:Print(L["The AddOn CompactRunes is not enabled. Profile not created."])
		end
		
		if IsAddOnLoaded('xCT+') then
			E:Print(L["A profile for xCT has been created."])
			InstallStepComplete:Show()
			xCTSavedDB['profiles']['Skullflower'] = {
			["frames"] = {
				["general"] = {
					["enabledFrame"] = false,
					["font"] = "Expressway",
					["colors"] = {
						["auras"] = {
							["colors"] = {
								["debuffsGained"] = {
									["color"] = {
										1, -- [1]
										0.1, -- [2]
										0.1, -- [3]
									},
								},
								["buffsGained"] = {
									["color"] = {
										1, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["buffsFaded"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["debuffsFaded"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
							},
						},
						["killingBlow"] = {
							["color"] = {
								0.2, -- [1]
								1, -- [2]
								0.2, -- [3]
							},
						},
						["combat"] = {
							["colors"] = {
								["combatLeaving"] = {
									["color"] = {
										0.1, -- [1]
										1, -- [2]
										0.1, -- [3]
									},
								},
								["combatEntering"] = {
									["color"] = {
										1, -- [1]
										0.1, -- [2]
										0.1, -- [3]
									},
								},
							},
						},
						["interrupts"] = {
							["color"] = {
								1, -- [1]
								0.5, -- [2]
								0, -- [3]
							},
						},
						["reputation"] = {
							["colors"] = {
								["reputationGain"] = {
									["color"] = {
										0.1, -- [1]
										0.1, -- [2]
										1, -- [3]
									},
								},
								["reputationLoss"] = {
									["color"] = {
										1, -- [1]
										0.1, -- [2]
										0.1, -- [3]
									},
								},
							},
						},
						["lowResources"] = {
							["colors"] = {
								["lowResourcesMana"] = {
									["color"] = {
										1, -- [1]
										0.1, -- [2]
										0.1, -- [3]
									},
								},
								["lowResourcesHealth"] = {
									["color"] = {
										1, -- [1]
										0.1, -- [2]
										0.1, -- [3]
									},
								},
							},
						},
						["honorGains"] = {
							["color"] = {
								0.1, -- [1]
								0.1, -- [2]
								1, -- [3]
							},
						},
						["dispells"] = {
							["colors"] = {
								["dispellBuffs"] = {
									["color"] = {
										0, -- [1]
										1, -- [2]
										0.5, -- [3]
									},
								},
								["dispellStolen"] = {
									["color"] = {
										0.31, -- [1]
										0.71, -- [2]
										1, -- [3]
									},
								},
								["dispellDebuffs"] = {
									["color"] = {
										1, -- [1]
										0, -- [2]
										0.5, -- [3]
									},
								},
							},
						},
					},
					["fontOutline"] = "2OUTLINE",
				},
				["power"] = {
					["enabledFrame"] = false,
					["fontOutline"] = "2OUTLINE",
					["font"] = "Expressway",
				},
				["healing"] = {
					["enableRealmNames"] = false,
					["showFriendlyHealers"] = false,
					["fontSize"] = 12,
					["Height"] = 196,
					["Width"] = 128,
					["Y"] = 47,
					["font"] = "Expressway",
					["colors"] = {
						["healingTakenCritical"] = {
							["color"] = {
								0.1, -- [1]
								1, -- [2]
								0.1, -- [3]
							},
						},
						["healingTaken"] = {
							["color"] = {
								0.1, -- [1]
								0.75, -- [2]
								0.1, -- [3]
							},
						},
						["shieldTaken"] = {
							["color"] = {
								0.6, -- [1]
								0.65, -- [2]
								1, -- [3]
							},
						},
						["healingTakenPeriodic"] = {
							["color"] = {
								0.1, -- [1]
								0.5, -- [2]
								0.1, -- [3]
							},
						},
					},
					["X"] = -208,
					["fontOutline"] = "2OUTLINE",
				},
				["outgoing"] = {
					["fontSize"] = 12,
					["Height"] = 196,
					["X"] = 209,
					["Width"] = 128,
					["Y"] = 47,
					["font"] = "Expressway",
					["colors"] = {
						["genericDamage"] = {
							["color"] = {
								1, -- [1]
								0.82, -- [2]
								0, -- [3]
							},
						},
						["healingSpells"] = {
							["colors"] = {
								["healingOut"] = {
									["color"] = {
										0.1, -- [1]
										0.75, -- [2]
										0.1, -- [3]
									},
								},
								["shieldOut"] = {
									["color"] = {
										0.6, -- [1]
										0.65, -- [2]
										1, -- [3]
									},
								},
								["healingOutPeriodic"] = {
									["color"] = {
										0.1, -- [1]
										0.5, -- [2]
										0.1, -- [3]
									},
								},
							},
						},
						["spellSchools"] = {
							["colors"] = {
								["SpellSchool_Nature"] = {
									["color"] = {
										0.3, -- [1]
										1, -- [2]
										0.3, -- [3]
									},
								},
								["SpellSchool_Arcane"] = {
									["color"] = {
										1, -- [1]
										0.5, -- [2]
										1, -- [3]
									},
								},
								["SpellSchool_Frost"] = {
									["color"] = {
										0.5, -- [1]
										1, -- [2]
										1, -- [3]
									},
								},
								["SpellSchool_Physical"] = {
									["color"] = {
										1, -- [1]
										1, -- [2]
										0, -- [3]
									},
								},
								["SpellSchool_Shadow"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										1, -- [3]
									},
								},
								["SpellSchool_Holy"] = {
									["color"] = {
										1, -- [1]
										0.9, -- [2]
										0.5, -- [3]
									},
								},
								["SpellSchool_Fire"] = {
									["color"] = {
										1, -- [1]
										0.5, -- [2]
										0, -- [3]
									},
								},
							},
						},
						["misstypesOut"] = {
							["color"] = {
								0.5, -- [1]
								0.5, -- [2]
								0.5, -- [3]
							},
						},
					},
					["fontOutline"] = "2OUTLINE",
				},
				["critical"] = {
					["fontSize"] = 12,
					["Height"] = 144,
					["X"] = 209,
					["Width"] = 128,
					["Y"] = -124,
					["font"] = "Expressway",
					["colors"] = {
						["genericDamageCritical"] = {
							["color"] = {
								1, -- [1]
								1, -- [2]
								0, -- [3]
							},
						},
						["healingSpells"] = {
							["colors"] = {
								["healingOutCritical"] = {
									["color"] = {
										0.1, -- [1]
										1, -- [2]
										0.1, -- [3]
									},
								},
							},
						},
					},
					["fontOutline"] = "2OUTLINE",
				},
				["procs"] = {
					["enabledFrame"] = false,
					["font"] = "Expressway",
					["colors"] = {
						["spellReactive"] = {
							["color"] = {
								1, -- [1]
								0.82, -- [2]
								0, -- [3]
							},
						},
						["spellProc"] = {
							["color"] = {
								1, -- [1]
								0.82, -- [2]
								0, -- [3]
							},
						},
					},
					["fontOutline"] = "2OUTLINE",
				},
				["loot"] = {
					["fontOutline"] = "2OUTLINE",
					["enabledFrame"] = false,
					["font"] = "Expressway",
				},
				["class"] = {
					["font"] = "Expressway",
					["colors"] = {
						["comboPoints"] = {
							["color"] = {
								1, -- [1]
								0.82, -- [2]
								0, -- [3]
							},
						},
						["comboPointsMax"] = {
							["color"] = {
								0, -- [1]
								0.82, -- [2]
								1, -- [3]
							},
						},
					},
					["enabledFrame"] = false,
					["fontOutline"] = "2OUTLINE",
				},
				["damage"] = {
					["fontSize"] = 12,
					["Y"] = -124,
					["font"] = "Expressway",
					["colors"] = {
						["missTypesTaken"] = {
							["colors"] = {
								["missTypeBlock"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeMiss"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeImmune"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeDodge"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeParry"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeResist"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeEvade"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeAbsorb"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeReflect"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
								["missTypeDeflect"] = {
									["color"] = {
										0.5, -- [1]
										0.5, -- [2]
										0.5, -- [3]
									},
								},
							},
						},
						["damageTakenCritical"] = {
							["color"] = {
								1, -- [1]
								0.1, -- [2]
								0.1, -- [3]
							},
						},
						["spellDamageTaken"] = {
							["color"] = {
								0.75, -- [1]
								0.3, -- [2]
								0.85, -- [3]
							},
						},
						["damageTaken"] = {
							["color"] = {
								0.75, -- [1]
								0.1, -- [2]
								0.1, -- [3]
							},
						},
						["spellDamageTakenCritical"] = {
							["color"] = {
								0.75, -- [1]
								0.3, -- [2]
								0.85, -- [3]
							},
						},
					},
					["X"] = -208,
					["fontOutline"] = "2OUTLINE",
				},
			},
			
			}
		else
			E:Print(L["The AddOn xCT is not enabled. Profile not created."])
		end
		
	end
end

local function InstallComplete()
	E.private.install_complete = E.version
	
	ReloadUI()
end
		
local function ResetAll()
	InstallNextButton:Disable()
	InstallPrevButton:Disable()
	InstallOption1Button:Hide()
	InstallOption1Button:SetScript("OnClick", nil)
	InstallOption1Button:SetText("")
	InstallOption2Button:Hide()
	InstallOption2Button:SetScript('OnClick', nil)
	InstallOption2Button:SetText('')
	InstallOption3Button:Hide()
	InstallOption3Button:SetScript('OnClick', nil)
	InstallOption3Button:SetText('')	
	InstallOption4Button:Hide()
	InstallOption4Button:SetScript('OnClick', nil)
	InstallOption4Button:SetText('')
	InstallOption5Button:Hide()
	InstallOption5Button:SetScript('OnClick', nil)
	InstallOption5Button:SetText('')
	InstallOption6Button:Hide()
	InstallOption6Button:SetScript('OnClick', nil)
	InstallOption6Button:SetText('')
	InstallOption7Button:Hide()
	InstallOption7Button:SetScript('OnClick', nil)
	InstallOption7Button:SetText('')
	InstallOption8Button:Hide()
	InstallOption8Button:SetScript('OnClick', nil)
	InstallOption8Button:SetText('')
	InstallOption9Button:Hide()
	InstallOption9Button:SetScript('OnClick', nil)
	InstallOption9Button:SetText('')
	InstallOption10Button:Hide()
	InstallOption10Button:SetScript('OnClick', nil)
	InstallOption10Button:SetText('')
	InstallOption11Button:Hide()
	InstallOption11Button:SetScript('OnClick', nil)
	InstallOption11Button:SetText('')
	InstallOption12Button:Hide()
	InstallOption12Button:SetScript('OnClick', nil)
	InstallOption12Button:SetText('')
	ElvUIInstallFrame:Size(206, 150)
	ElvUIInstallFrame:SetAlpha(0.6)
end

local function SetPage(PageNum)
	CURRENT_PAGE = PageNum
	ResetAll()
	
	local f = ElvUIInstallFrame
	
	if PageNum == 5 then
		InstallNextButton:Hide()
		InstallNextButton:Disable()
		InstallPrevButton:Enable()
		f.tutorialImage3:Hide()	
	else
		f.tutorialImage3:Show()
		InstallNextButton:Show()
		InstallNextButton:Enable()
	end
	
	if PageNum == 1 then
		InstallPrevButton:Hide()
		InstallPrevButton:Disable()
		f.tutorialImage2:Hide()	
	else
		f.tutorialImage2:Show()	
		InstallPrevButton:Show()
		InstallPrevButton:Enable()
	end
	
	if PageNum == 2 then
		f.tutorialImage5:Show()
	else
		f.tutorialImage5:Hide()
	end
	

	if PageNum == 1 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript('OnClick', function() E:SetupTheme('SkullflowerUI') end)
		InstallOption8Button:SetText(L['|cffffffffInstall UI|r'])	
	elseif PageNum == 2 then
		InstallOption1Button:Show()
		InstallOption1Button:SetScript('OnClick', function() E:SetupTheme('sqAB') end)
		InstallOption1Button:SetText(L['|cffffffffSquare ActionBar'])
		
		InstallOption2Button:Show()
		InstallOption2Button:SetScript('OnClick', function() E:SetupTheme('unhideB') end)
		InstallOption2Button:SetText(L['|cffffffffUnhide Buttons'])
		
		InstallOption3Button:Show()
		InstallOption3Button:SetScript('OnClick', function() E:SetupTheme('unitT') end)
		InstallOption3Button:SetText(L['|cfffbc93dFrame Texts'])
		
		InstallOption4Button:Show()
		InstallOption4Button:SetScript('OnClick', function() E:SetupTheme('cBuffs') end)
		InstallOption4Button:SetText(L['|cfffbc93dConsolidated Buffs'])
		
		InstallOption5Button:Show()
		InstallOption5Button:SetScript('OnClick', function() E:SetupTheme('altUF') end)
		InstallOption5Button:SetText(L['|cff4ffb7cAlternate Frames'])
		InstallOption6Button:Show()
		
		InstallOption6Button:SetScript('OnClick', function() E:SetupTheme('healF') end)
		InstallOption6Button:SetText(L['|cff4ffb7cHeal Group Frames'])
		
		InstallOption10Button:Show()
		InstallOption10Button:SetScript('OnClick', function() E:SetupTheme('dataT') end)
		InstallOption10Button:SetText(L['|cfffb4f4fData Texts'])
		
		InstallOption11Button:Show()
		InstallOption11Button:SetScript('OnClick', function() E:SetupTheme('eToT') end)
		InstallOption11Button:SetText(L['|cfffb4f4fEnable ToT Frame'])
		
		InstallOption7Button:Show()
		InstallOption7Button:SetScript('OnClick', function() E:SetupTheme('resetTheme') end)
		InstallOption7Button:SetText(L['|cffffffffReset'])
		
		ElvUIInstallFrame:Size(206, 176)
	elseif PageNum == 3 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript("OnClick", function() E:SetupTheme('Gradient') end)
		InstallOption8Button:SetText(L["|cffffffffGradient Texture"])
		InstallOption9Button:Show()
		InstallOption9Button:SetScript("OnClick", function() E:SetupTheme('Basic') end)
		InstallOption9Button:SetText(L["|cffffffffBasic Texture"])
		InstallOption12Button:Show()
		InstallOption12Button:SetScript("OnClick", function() E:SetupTheme('Neon') end)
		InstallOption12Button:SetText(L["|cffffffffNeon Texture"])
	elseif PageNum == 4 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript("OnClick", SetupChat)
		InstallOption8Button:SetText(L["|cffffffffChat Settings"])
		InstallOption9Button:Show()
		InstallOption9Button:SetScript("OnClick", SetupCVars)
		InstallOption9Button:SetText(L["|cffffffffInterface Settings"])
		InstallOption12Button:Show()
		InstallOption12Button:SetScript("OnClick", function() E:SetupAddon('Skada') end)
		InstallOption12Button:SetText(L["|cffffffffAddOn Settings"])
	elseif PageNum == 5 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript("OnClick", InstallComplete)
		InstallOption8Button:SetText(L["|cffffffffFinish"])
	end
end

local function NextPage()	
	if CURRENT_PAGE ~= MAX_PAGE then
		CURRENT_PAGE = CURRENT_PAGE + 1
		SetPage(CURRENT_PAGE)
	end
end

local function PreviousPage()
	if CURRENT_PAGE ~= 1 then
		CURRENT_PAGE = CURRENT_PAGE - 1
		SetPage(CURRENT_PAGE)
	end
end

--Install UI
function E:Install()	
	if not InstallStepComplete then
		local imsg = CreateFrame("Frame", "InstallStepComplete", E.UIParent)
		imsg:Size(206, 150)
		imsg:Point("TOP", 0, -190)
		imsg:Hide()
		imsg:SetScript('OnShow', function(self)
			if self.message then 
				self.text:SetText(self.message)
				UIFrameFadeOut(self, 3.5, 1, 0)
				E:Delay(4, function() self:Hide() end)	
				self.message = nil

				if imsg.firstShow == false then			
					imsg.firstShow = true
				end
			else
				self:Hide()
			end
		end)

		imsg.firstShow = false

		imsg.bg = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.bg:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.bg:SetPoint('BOTTOM')
		imsg.bg:Size(206, 150)
		imsg.bg:SetTexCoord(0.00195313, 0.63867188, 0.03710938, 0.23828125)
		imsg.bg:SetVertexColor(1, 1, 1, 0.6)


		imsg.lineBottom = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineBottom:SetDrawLayer('BACKGROUND', 2)
		imsg.lineBottom:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineBottom:SetPoint("BOTTOM")
		imsg.lineBottom:Size(206, 150)
		imsg.lineBottom:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.text = imsg:CreateFontString(nil, 'ARTWORK', 'GameFont_Gigantic')
		imsg.text:Point("BOTTOM", 0, 12)
		imsg.text:SetTextColor(1, 0.82, 0)
		imsg.text:SetJustifyH("CENTER")
		
	end

	--Create Frame
	if not ElvUIInstallFrame then
		local f = CreateFrame("Button", "ElvUIInstallFrame", E.UIParent)
		f.SetPage = SetPage
		f:Size(206, 150)
		f:SetTemplate("Transparent")
		f:SetPoint("CENTER")
		f:SetFrameStrata('TOOLTIP')
		
		f.Next = CreateFrame("Button", "InstallNextButton", f, "UIPanelButtonTemplate")
		f.Next:StripTextures()
		f.Next:SetTemplate("Default", true)
		f.Next:SetAlpha(0)
		f.Next:Size(102, 30)
		f.Next:Point("RIGHT", 100, 0)
		f.Next:Disable()
		f.Next:SetScript("OnClick", NextPage)
		E.Skins:HandleButton(f.Next, true)
		
		f.Prev = CreateFrame("Button", "InstallPrevButton", f, "UIPanelButtonTemplate")
		f.Prev:StripTextures()
		f.Prev:SetTemplate("Default", true)
		f.Prev:SetAlpha(0)
		f.Prev:Size(100, 30)
		f.Prev:Point("LEFT", -102, 0)
		f.Prev:Disable()
		f.Prev:SetScript("OnClick", PreviousPage)
		E.Skins:HandleButton(f.Prev, true)
		
		f.Option1 = CreateFrame("Button", "InstallOption1Button", f, "UIPanelButtonTemplate")
		f.Option1:StripTextures()
		f.Option1:Size(100, 30)
		f.Option1:Point("BOTTOMLEFT", 2, 2)
		f.Option1:SetText("")
		f.Option1:Hide()
		E.Skins:HandleButton(f.Option1, true)
		
		f.Option2 = CreateFrame("Button", "InstallOption2Button", f, "UIPanelButtonTemplate")
		f.Option2:StripTextures()
		f.Option2:Size(100, 30)
		f.Option2:Point('BOTTOMRIGHT', -2, 2)
		f.Option2:SetText("")
		f.Option2:Hide()
		E.Skins:HandleButton(f.Option2, true)		
		
		f.Option3 = CreateFrame("Button", "InstallOption3Button", f, "UIPanelButtonTemplate")
		f.Option3:StripTextures()
		f.Option3:Size(100, 30)
		f.Option3:Point('BOTTOMLEFT', 2, 33)
		f.Option3:SetText("")
		f.Option3:Hide()
		E.Skins:HandleButton(f.Option3, true)	
		
		f.Option4 = CreateFrame("Button", "InstallOption4Button", f, "UIPanelButtonTemplate")
		f.Option4:StripTextures()
		f.Option4:Size(100, 30)
		f.Option4:Point("BOTTOMRIGHT", -2, 33)
		f.Option4:SetText("")
		E.Skins:HandleButton(f.Option4, true)
		
		f.Option5 = CreateFrame("Button", "InstallOption5Button", f, "UIPanelButtonTemplate")
		f.Option5:StripTextures()
		f.Option5:Size(100, 30)
		f.Option5:Point("BOTTOMLEFT", 2, 64)
		f.Option5:SetText("")
		E.Skins:HandleButton(f.Option5, true)
		
		f.Option6 = CreateFrame("Button", "InstallOption6Button", f, "UIPanelButtonTemplate")
		f.Option6:StripTextures()
		f.Option6:Size(100, 30)
		f.Option6:Point("BOTTOMRIGHT", -2, 64)
		f.Option6:SetText("")
		E.Skins:HandleButton(f.Option6, true)
		
		f.Option7 = CreateFrame("Button", "InstallOption7Button", f, "UIPanelButtonTemplate")
		f.Option7:StripTextures()
		f.Option7:SetAlpha(0)
		f.Option7:Size(100, 30)
		f.Option7:Point("BOTTOM", 0, -31)
		f.Option7:SetText("")
		E.Skins:HandleButton(f.Option7, true)
		
		f.Option8 = CreateFrame("Button", "InstallOption8Button", f, "UIPanelButtonTemplate")
		f.Option8:StripTextures()
		f.Option8:Size(100, 30)
		f.Option8:Point("CENTER", 0, -27)
		f.Option8:SetText("")
		E.Skins:HandleButton(f.Option8, true)
		
		f.Option9 = CreateFrame("Button", "InstallOption9Button", f, "UIPanelButtonTemplate")
		f.Option9:StripTextures()
		f.Option9:Size(100, 30)
		f.Option9:Point("CENTER", 0, 4)
		f.Option9:SetText("")
		E.Skins:HandleButton(f.Option9, true)
		
		f.Option10 = CreateFrame("Button", "InstallOption10Button", f, "UIPanelButtonTemplate")
		f.Option10:StripTextures()
		f.Option10:Size(100, 30)
		f.Option10:Point("BOTTOMLEFT", 2, 95)
		f.Option10:SetText("")
		E.Skins:HandleButton(f.Option10, true)
		
		f.Option11 = CreateFrame("Button", "InstallOption11Button", f, "UIPanelButtonTemplate")
		f.Option11:StripTextures()
		f.Option11:Size(100, 30)
		f.Option11:Point("BOTTOMRIGHT", -2, 95)
		f.Option11:SetText("")
		E.Skins:HandleButton(f.Option11, true)
		
		f.Option12 = CreateFrame("Button", "InstallOption12Button", f, "UIPanelButtonTemplate")
		f.Option12:StripTextures()
		f.Option12:Size(100, 30)
		f.Option12:Point("Bottom", 0, 2)
		f.Option12:SetText("")
		E.Skins:HandleButton(f.Option12, true)

		
		local close = CreateFrame("Button", "InstallCloseButton", f, "UIPanelCloseButton")
		close:Point("TOPRIGHT", f, "TOPRIGHT", -6, -6)
		close:SetScript("OnClick", function()
			f:Hide()
		end)		
		InstallCloseButton:SetAlpha(0)
		E.Skins:HandleCloseButton(close)

		f.tutorialImage = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage:SetTexture('Interface\\AddOns\\ElvUI_Skullflower\\media\\textures\\SkullflowerUI.tga')
		f.tutorialImage:Point('TOP', 0, 35)
		
		f.tutorialImage2 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage2:SetTexture('Interface\\AddOns\\ElvUI_Skullflower\\media\\textures\\arrowLeft.tga')
		f.tutorialImage2:Point('LEFT', "ElvUIInstallFrame", -35, 0)
		
		f.tutorialImage3 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage3:SetTexture('Interface\\AddOns\\ElvUI_Skullflower\\media\\textures\\arrowRight.tga')
		f.tutorialImage3:Point('RIGHT', "ElvUIInstallFrame", 35, 0)
		
		f.tutorialImage4 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage4:SetTexture('Interface\\AddOns\\ElvUI_Skullflower\\media\\textures\\close.tga')
		f.tutorialImage4:Point("TOPRIGHT", f, "TOPRIGHT", -6, -6)
		
		f.tutorialImage5 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage5:SetTexture('Interface\\AddOns\\ElvUI_Skullflower\\media\\textures\\reset.tga')
		f.tutorialImage5:Point("BOTTOM", "ElvUIInstallFrame", 0, -50)

	end
	
	ElvUIInstallFrame:Show()
	NextPage()
end